var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, Fragment as _Fragment } from "react/jsx-runtime";
import dynamic from 'next/dynamic';
import { useDeep, useDeepId } from "@deep-foundation/deeplinks/imports/client";
import React, { useCallback, useEffect, useRef, useState } from 'react';
import { evalClientHandler } from './client-handler';
import { useDebounceCallback } from '@react-hook/debounce';
import { useCytoHandlersSwitch } from './hooks';
import { useCytoHandlersRules } from './cyto/hooks';
const MonacoEditor = dynamic(() => import('@monaco-editor/react').then(m => m.default), { ssr: false });
;
export function useCytoHandlers() {
    const ref = useRef({});
    const drawedCytoHandlers = useRef({});
    const [iterator, setIterator] = useState(0);
    const onChangeDebounce = useDebounceCallback(() => {
        setIterator(i => i + 1);
    }, 300);
    const onChange = useCallback((id, r) => {
        if (!r) {
            delete ref.current[id];
            onChangeDebounce();
        }
        else if (!r.error) {
            ref.current[id] = r;
            onChangeDebounce();
        }
    }, []);
    return { cytoHandlersRef: ref, drawedCytoHandlers, iterator, setIterator, onChange };
}
export function useCytoHandlersApply(cyh, elements, stylesheets, iterator) {
    var _a, _b, _c, _d;
    const [cytoHandlers, setCytoHandlers] = useCytoHandlersSwitch();
    const deep = useDeep();
    const [chr, setChr] = useCytoHandlersRules();
    const { data: HandleCyto } = useDeepId('@deep-foundation/handle-cyto', 'HandleCyto');
    cyh.drawedCytoHandlers.current = {};
    const addElements = [];
    const stylesheetsByHandler = {};
    if (cytoHandlers) {
        for (let key in (_a = cyh === null || cyh === void 0 ? void 0 : cyh.cytoHandlersRef) === null || _a === void 0 ? void 0 : _a.current) {
            const el = (_b = cyh === null || cyh === void 0 ? void 0 : cyh.cytoHandlersRef) === null || _b === void 0 ? void 0 : _b.current[key];
            const cyHandle = (_d = (_c = deep.minilinks) === null || _c === void 0 ? void 0 : _c.byType[HandleCyto]) === null || _d === void 0 ? void 0 : _d.find(l => { var _a, _b; return l.from_id === ((_b = (_a = deep.minilinks.byId) === null || _a === void 0 ? void 0 : _a[key]) === null || _b === void 0 ? void 0 : _b.type_id); });
            if (el && chr[cyHandle === null || cyHandle === void 0 ? void 0 : cyHandle.id]) {
                cyh.drawedCytoHandlers.current[key] = el;
                addElements.push(...el.elements || []);
                stylesheetsByHandler[el === null || el === void 0 ? void 0 : el.handlerId] = el.stylesheets || [];
            }
        }
        elements.push(...addElements);
        for (let key in stylesheetsByHandler) {
            stylesheets.push(...stylesheetsByHandler[key]);
        }
    }
}
export function CytoHandlers({ onChange, handled, elementsById, cy, }) {
    const { data: HandleCyto } = useDeepId('@deep-foundation/handle-cyto', 'HandleCyto');
    const arr = [];
    for (let key in handled) {
        arr.push(_jsx(CytoHandler, { linkId: +key, handlerId: handled[key], onChange: onChange, elementsById: elementsById, HandleCyto: HandleCyto }, +key));
    }
    return _jsx(_Fragment, { children: HandleCyto ? arr : [] });
}
export const CytoHandler = React.memo(function CytoHandler(_a) {
    var _b;
    var { linkId, handlerId, onChange, elementsById, cy, HandleCyto } = _a, props = __rest(_a, ["linkId", "handlerId", "onChange", "elementsById", "cy", "HandleCyto"]);
    const deep = useDeep();
    const ml = deep === null || deep === void 0 ? void 0 : deep.minilinks;
    const [file] = deep.useMinilinksSubscription({
        in: {
            type_id: deep.idLocal('@deep-foundation/core', 'Handler'),
            in: {
                type_id: HandleCyto,
                from_id: ml.byId[linkId].type_id,
            },
        },
    });
    const [Component, setComponent] = React.useState(null);
    const lastEvalRef = useRef(0);
    useEffect(() => {
        var _a;
        const value = (_a = file === null || file === void 0 ? void 0 : file.value) === null || _a === void 0 ? void 0 : _a.value;
        console.log('CytoHandler evalClientHandler', { file, value });
        if (!value) {
            return;
        }
        const evalId = ++lastEvalRef.current;
        evalClientHandler({ value, deep }).then(({ data, error }) => {
            if (evalId === lastEvalRef.current) {
                console.log('CytoHandler evalClientHandler setComponent', { file, data, error });
                if (!error)
                    setComponent(() => data);
                else
                    setComponent(undefined);
            }
            else {
                console.log('CytoHandler evalClientHandler outdated', { file, data, error, evalId, 'lastEvalRef.current': lastEvalRef.current });
            }
        });
        return () => {
            onChange(linkId);
        };
    }, [(_b = file === null || file === void 0 ? void 0 : file.value) === null || _b === void 0 ? void 0 : _b.value]);
    try {
        const r = Component ? Component(Object.assign({ link: ml.byId[linkId], elementsById, cy }, props)) : {};
        onChange(linkId, Object.assign(Object.assign({}, r), { handlerId }));
    }
    catch (error) {
        onChange(linkId, { error, handlerId });
    }
    return _jsx(_Fragment, {});
}, () => true);
//# sourceMappingURL=cyto-handler.js.map