var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { jsxs as _jsxs, jsx as _jsx } from "react/jsx-runtime";
import { Box } from '@chakra-ui/react';
import { useDeep } from '@deep-foundation/deeplinks/imports/client';
import { useDropzone } from 'react-dropzone';
import { useContainer, useSpaceId } from '../hooks';
import axios from 'axios';
let counter = 0;
export function CytoDropZone({ cy, children, gqlPath, gqlSsl, render = ({ getRootProps, input, isDragAccept, isDragActive, isDragReject, children, }) => (_jsx(Box, { children: _jsxs(Box, Object.assign({}, getRootProps({}), { onClick: () => { }, position: "fixed", left: 0, top: 0, w: '100%', h: '100%', bg: isDragActive ? 'blue' : isDragAccept ? 'green' : isDragReject ? 'red' : 'transparent', children: [input, children] })) })), }) {
    const deep = useDeep();
    const [container] = useContainer();
    const [space] = useSpaceId();
    const onDrop = (files, a, event) => __awaiter(this, void 0, void 0, function* () {
        const pan = cy.pan();
        const zoom = cy.zoom();
        console.log(event, cy, pan, zoom);
        const id = counter++;
        const _id = `file-${id}`;
        const file = files[0];
        if (container) {
            try {
                const { data: [{ id }] } = yield deep.insert({
                    type_id: deep.idLocal('@deep-foundation/core', 'AsyncFile'),
                    in: { data: [
                            {
                                type_id: deep.idLocal('@deep-foundation/core', 'Contain'),
                                from_id: container,
                            },
                            {
                                type_id: deep.idLocal('@deep-foundation/core', 'Focus'),
                                from_id: space,
                                object: { data: { value: { x: ((event.clientX) - (pan.x)) / zoom, y: ((event.clientY) - (pan.y)) / zoom } } },
                                in: { data: [
                                        {
                                            type_id: deep.idLocal('@deep-foundation/core', 'Contain'),
                                            from_id: container,
                                        },
                                    ] },
                            },
                        ] },
                });
                console.log('drop-zone id file', id, file);
                var formData = new FormData();
                formData.append("file", file);
                console.log('drop-zone formData', formData);
                yield axios.post(`http${gqlSsl ? 's' : ''}://${gqlPath.slice(0, -4)}/file`, formData, {
                    headers: {
                        'linkId': id,
                        "Authorization": `Bearer ${deep.token}`,
                    },
                });
                console.log('drop-zone finish');
            }
            catch (error) {
                console.error(error);
            }
        }
    });
    const { getRootProps, getInputProps, isDragActive, isDragAccept, isDragReject, } = useDropzone({
        onDrop
    });
    const input = _jsx("input", Object.assign({}, getInputProps()));
    return render({
        getRootProps,
        input,
        isDragActive,
        isDragAccept,
        isDragReject,
        children,
        deep,
    });
}
//# sourceMappingURL=drop-zone.js.map