import { useDeep, useDeepId } from '@deep-foundation/deeplinks/imports/client';
import json5 from 'json5';
import { useRef } from 'react';
import { useCytoHandlersSwitch, useInsertingCytoStore, useShowFocus, useShowTypes } from '../hooks';
import { useCytoHandlersRules } from './hooks';
export function useCytoElements(ml, _links, cy, spaceId, cyh) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20, _21, _22, _23, _24, _25, _26, _27, _28, _29, _30, _31, _32, _33, _34, _35, _36, _37, _38, _39, _40, _41, _42, _43, _44, _45, _46, _47, _48, _49;
    const [showTypes, setShowTypes] = useShowTypes();
    const [showFocus, setShowFocus] = useShowFocus();
    const [cytoHandlers, setCytoHandlers] = useCytoHandlersSwitch();
    const [chr, setChr] = useCytoHandlersRules();
    const [insertingCyto, setInsertingCyto] = useInsertingCytoStore();
    const oldElements = useRef([]);
    const deep = useDeep();
    const { data: HandleCyto } = useDeepId('@deep-foundation/handle-cyto', 'HandleCyto');
    const links = _links;
    const elementsById = {};
    const cytoHandled = {};
    let elements = [];
    const reactElements = [];
    for (let i = 0; i < links.length; i++) {
        const link = links[i];
        const cyHandle = (_b = (_a = deep.minilinks) === null || _a === void 0 ? void 0 : _a.byType[HandleCyto]) === null || _b === void 0 ? void 0 : _b.find(l => l.from_id === link.type_id);
        if (cyh.drawedCytoHandlers.current[link.id] && (!cytoHandlers || !chr[cyHandle === null || cyHandle === void 0 ? void 0 : cyHandle.id])) {
            continue;
        }
        if (cytoHandlers && cyHandle && !!chr[cyHandle === null || cyHandle === void 0 ? void 0 : cyHandle.id]) {
            cytoHandled[link.id] = cyHandle === null || cyHandle === void 0 ? void 0 : cyHandle.to_id;
            continue;
        }
        const focus = (_d = (_c = link === null || link === void 0 ? void 0 : link.inByType) === null || _c === void 0 ? void 0 : _c[deep.idLocal('@deep-foundation/core', 'Focus')]) === null || _d === void 0 ? void 0 : _d.find(f => f.from_id === spaceId);
        const isFocusSpace = (link.type_id === deep.idLocal('@deep-foundation/core', 'Focus') && link._applies.includes('space')) || (((_e = link === null || link === void 0 ? void 0 : link.to) === null || _e === void 0 ? void 0 : _e.type_id) === deep.idLocal('@deep-foundation/core', 'Focus') && link._applies.includes('space'));
        let _value = '';
        let _name = '';
        let _type = '';
        let _symbol = '';
        if (typeof ((_f = link === null || link === void 0 ? void 0 : link.value) === null || _f === void 0 ? void 0 : _f.value) !== 'undefined') {
            let json;
            try {
                json = json5.stringify(link === null || link === void 0 ? void 0 : link.value.value);
            }
            catch (error) { }
            _value = (typeof (link === null || link === void 0 ? void 0 : link.value.value) === 'object' && json
                ? json : link === null || link === void 0 ? void 0 : link.value.value);
            if (typeof (_value) === 'string')
                _value = _value.split('\n')[0];
            if (_value.length > 20)
                _value = _value.slice(0, 11) + '...' + _value.slice(-9, _value.length);
        }
        if ((_k = (_j = (_h = (_g = link === null || link === void 0 ? void 0 : link.inByType) === null || _g === void 0 ? void 0 : _g[deep.idLocal('@deep-foundation/core', 'Contain')]) === null || _h === void 0 ? void 0 : _h[0]) === null || _j === void 0 ? void 0 : _j.value) === null || _k === void 0 ? void 0 : _k.value) {
            _name = `name:${(_p = (_o = (_m = (_l = link === null || link === void 0 ? void 0 : link.inByType) === null || _l === void 0 ? void 0 : _l[deep.idLocal('@deep-foundation/core', 'Contain')]) === null || _m === void 0 ? void 0 : _m[0]) === null || _o === void 0 ? void 0 : _o.value) === null || _p === void 0 ? void 0 : _p.value}`;
        }
        if ((_s = (_r = (_q = ml.byTo[link === null || link === void 0 ? void 0 : link.type_id]) === null || _q === void 0 ? void 0 : _q.find(l => l.type_id === deep.idLocal('@deep-foundation/core', 'Contain'))) === null || _r === void 0 ? void 0 : _r.value) === null || _s === void 0 ? void 0 : _s.value) {
            _type = `type:${(_v = (_u = (_t = ml.byTo[link === null || link === void 0 ? void 0 : link.type_id]) === null || _t === void 0 ? void 0 : _t.find(l => l.type_id === deep.idLocal('@deep-foundation/core', 'Contain'))) === null || _u === void 0 ? void 0 : _u.value) === null || _v === void 0 ? void 0 : _v.value}`;
        }
        if ((_y = (_x = (_w = ml.byTo[link === null || link === void 0 ? void 0 : link.type_id]) === null || _w === void 0 ? void 0 : _w.find(l => l.type_id === deep.idLocal('@deep-foundation/core', 'Symbol'))) === null || _x === void 0 ? void 0 : _x.value) === null || _y === void 0 ? void 0 : _y.value) {
            _symbol = (_1 = (_0 = (_z = ml.byTo[link === null || link === void 0 ? void 0 : link.type_id]) === null || _z === void 0 ? void 0 : _z.find(l => l.type_id === deep.idLocal('@deep-foundation/core', 'Symbol'))) === null || _0 === void 0 ? void 0 : _0.value) === null || _1 === void 0 ? void 0 : _1.value;
        }
        function isValidValue(value) {
            return value !== null && typeof value !== 'undefined' && !Number.isNaN(value) && value !== '';
        }
        const has_focus = !!((_3 = (_2 = focus === null || focus === void 0 ? void 0 : focus.value) === null || _2 === void 0 ? void 0 : _2.value) === null || _3 === void 0 ? void 0 : _3.x);
        const existed = !!oldElements.current.find((oldLink) => oldLink.id === link.id);
        const element = Object.assign(Object.assign({ id: link.id, data: {
                id: `${link.id}`,
                label: (`${link.id}`
                    + (_type ? '\n' + `${_type}` : '')
                    + (_name ? '\n' + `${_name}` : '')
                    + (isValidValue(_value) ? '\n' + `${_value}` : '')
                    + `\n\n ${_symbol || '📍'}`),
                link,
            }, selectable: false, classes: [
                'link-node',
                ...(focus ? ['focused'] : ['unfocused']),
            ].join(' ') }, (has_focus ? {
            position: !existed ? (_4 = focus === null || focus === void 0 ? void 0 : focus.value) === null || _4 === void 0 ? void 0 : _4.value : {},
            locked: !!focus,
        } : {})), { focused: !!focus });
        if ((isFocusSpace && showFocus) || !isFocusSpace) {
            elementsById[link === null || link === void 0 ? void 0 : link.id] = element;
            elements.push(element);
        }
    }
    for (let i = 0; i < links.length; i++) {
        const link = links[i];
        if (cytoHandled[link === null || link === void 0 ? void 0 : link.id])
            continue;
        if (cyh.drawedCytoHandlers.current[link.id] && !cytoHandlers) {
            continue;
        }
        const focus = (_6 = (_5 = link === null || link === void 0 ? void 0 : link.inByType) === null || _5 === void 0 ? void 0 : _5[deep.idLocal('@deep-foundation/core', 'Focus')]) === null || _6 === void 0 ? void 0 : _6.find(f => f.from_id === spaceId);
        const isFocusSpace = (link.type_id === deep.idLocal('@deep-foundation/core', 'Focus') && link._applies.includes('space')) || (((_7 = link === null || link === void 0 ? void 0 : link.to) === null || _7 === void 0 ? void 0 : _7.type_id) === deep.idLocal('@deep-foundation/core', 'Focus') && link._applies.includes('space'));
        let _value = '';
        let _name = '';
        let _type = '';
        let _symbol = '';
        if ((_8 = link === null || link === void 0 ? void 0 : link.value) === null || _8 === void 0 ? void 0 : _8.value) {
            let json;
            try {
                json = json5.stringify(link === null || link === void 0 ? void 0 : link.value.value);
            }
            catch (error) { }
            _value = (typeof (link === null || link === void 0 ? void 0 : link.value.value) === 'object' && json
                ? json : link === null || link === void 0 ? void 0 : link.value.value);
        }
        if ((_12 = (_11 = (_10 = (_9 = link === null || link === void 0 ? void 0 : link.inByType) === null || _9 === void 0 ? void 0 : _9[deep.idLocal('@deep-foundation/core', 'Contain')]) === null || _10 === void 0 ? void 0 : _10[0]) === null || _11 === void 0 ? void 0 : _11.value) === null || _12 === void 0 ? void 0 : _12.value) {
            _name = `name:${(_16 = (_15 = (_14 = (_13 = link === null || link === void 0 ? void 0 : link.inByType) === null || _13 === void 0 ? void 0 : _13[deep.idLocal('@deep-foundation/core', 'Contain')]) === null || _14 === void 0 ? void 0 : _14[0]) === null || _15 === void 0 ? void 0 : _15.value) === null || _16 === void 0 ? void 0 : _16.value}`;
        }
        if ((_21 = (_20 = (_19 = (_18 = (_17 = link === null || link === void 0 ? void 0 : link.type) === null || _17 === void 0 ? void 0 : _17.inByType) === null || _18 === void 0 ? void 0 : _18[deep.idLocal('@deep-foundation/core', 'Contain')]) === null || _19 === void 0 ? void 0 : _19[0]) === null || _20 === void 0 ? void 0 : _20.value) === null || _21 === void 0 ? void 0 : _21.value) {
            _type = `type:${(_26 = (_25 = (_24 = (_23 = (_22 = link === null || link === void 0 ? void 0 : link.type) === null || _22 === void 0 ? void 0 : _22.inByType) === null || _23 === void 0 ? void 0 : _23[deep.idLocal('@deep-foundation/core', 'Contain')]) === null || _24 === void 0 ? void 0 : _24[0]) === null || _25 === void 0 ? void 0 : _25.value) === null || _26 === void 0 ? void 0 : _26.value}`;
        }
        if ((_31 = (_30 = (_29 = (_28 = (_27 = link === null || link === void 0 ? void 0 : link.type) === null || _27 === void 0 ? void 0 : _27.inByType) === null || _28 === void 0 ? void 0 : _28[deep.idLocal('@deep-foundation/core', 'Symbol')]) === null || _29 === void 0 ? void 0 : _29[0]) === null || _30 === void 0 ? void 0 : _30.value) === null || _31 === void 0 ? void 0 : _31.value) {
            _symbol = (_36 = (_35 = (_34 = (_33 = (_32 = link === null || link === void 0 ? void 0 : link.type) === null || _32 === void 0 ? void 0 : _32.inByType) === null || _33 === void 0 ? void 0 : _33[deep.idLocal('@deep-foundation/core', 'Symbol')]) === null || _34 === void 0 ? void 0 : _34[0]) === null || _35 === void 0 ? void 0 : _35.value) === null || _36 === void 0 ? void 0 : _36.value;
        }
        if (!!cy && (!cyh.drawedCytoHandlers.current[link.id] || !cytoHandlers)) {
            if ((isFocusSpace && showFocus) || !isFocusSpace) {
                if (link.from_id) {
                    if (((_37 = ml === null || ml === void 0 ? void 0 : ml.byId) === null || _37 === void 0 ? void 0 : _37[link.from_id]) && elementsById[link.from_id]) {
                        elements.push({
                            data: { id: `${link.id}-from`, source: `${link.id}`, target: `${link.from_id}`, link },
                            selectable: false,
                            classes: [
                                'link-from',
                                ...(focus ? ['focused'] : ['unfocused'])
                            ].join(' '),
                        });
                    }
                }
                if (link.to_id) {
                    if (((_38 = ml === null || ml === void 0 ? void 0 : ml.byId) === null || _38 === void 0 ? void 0 : _38[link.to_id]) && elementsById[link.to_id]) {
                        elements.push({
                            data: { id: `${link.id}-to`, source: `${link.id}`, target: `${link.to_id}`, link },
                            selectable: false,
                            classes: [
                                'link-to',
                                ...(focus ? ['focused'] : ['unfocused'])
                            ].join(' '),
                        });
                    }
                }
                if (showTypes) {
                    if (link.type_id) {
                        if (((_39 = ml === null || ml === void 0 ? void 0 : ml.byId) === null || _39 === void 0 ? void 0 : _39[link.type_id]) && elementsById[link.type_id]) {
                            elements.push({
                                data: { id: `${link.id}-type`, source: `${link.id}`, target: `${link.type_id}`, link },
                                selectable: false,
                                classes: [
                                    'link-type',
                                    ...(focus ? ['focused'] : ['unfocused'])
                                ].join(' '),
                            });
                        }
                    }
                }
            }
        }
    }
    for (let i = 0; i < elements.length; i++) {
        const el = elements[i];
        if (((_40 = el === null || el === void 0 ? void 0 : el.data) === null || _40 === void 0 ? void 0 : _40.source) && !elementsById[(_41 = el === null || el === void 0 ? void 0 : el.data) === null || _41 === void 0 ? void 0 : _41.source] && !cytoHandled[(_42 = el === null || el === void 0 ? void 0 : el.data) === null || _42 === void 0 ? void 0 : _42.source] && !cyh.drawedCytoHandlers.current[(_43 = el === null || el === void 0 ? void 0 : el.data) === null || _43 === void 0 ? void 0 : _43.source]) {
            const id = (_44 = el === null || el === void 0 ? void 0 : el.data) === null || _44 === void 0 ? void 0 : _44.source;
            const element = {
                id: id,
                data: {
                    id: `${id}`,
                    label: (`${id}\n\n `),
                },
                selectable: false,
                classes: [
                    'link-node',
                ].join(' '),
            };
            elementsById[id] = element;
            elements.push(element);
        }
        if (((_45 = el === null || el === void 0 ? void 0 : el.data) === null || _45 === void 0 ? void 0 : _45.target) && !elementsById[(_46 = el === null || el === void 0 ? void 0 : el.data) === null || _46 === void 0 ? void 0 : _46.target] && !cytoHandled[(_47 = el === null || el === void 0 ? void 0 : el.data) === null || _47 === void 0 ? void 0 : _47.target] && !cyh.drawedCytoHandlers.current[(_48 = el === null || el === void 0 ? void 0 : el.data) === null || _48 === void 0 ? void 0 : _48.target]) {
            const id = (_49 = el === null || el === void 0 ? void 0 : el.data) === null || _49 === void 0 ? void 0 : _49.target;
            const element = {
                id: id,
                data: {
                    id: `${id}`,
                    label: (`${id}\n\n `),
                },
                selectable: false,
                classes: [
                    'link-node',
                ].join(' '),
            };
            elementsById[id] = element;
            elements.push(element);
        }
    }
    oldElements.current = elements;
    return {
        elementsById, elements, reactElements, cytoHandled,
    };
}
//# sourceMappingURL=elements.js.map