var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import cytoscape from 'cytoscape';
import edgeConnections from 'cytoscape-edge-connections';
import { useRef, useState } from 'react';
import dagre from 'cytoscape-dagre';
import { useDeep } from '@deep-foundation/deeplinks/imports/client';
import cola from 'cytoscape-cola';
import d3Force from 'cytoscape-d3-force';
import deepd3Force from 'cytoscape-deep-d3-force';
import cxtmenu from './cxtmenu';
import edgehandles from 'cytoscape-edgehandles';
import { Text, useToast } from '@chakra-ui/react';
import dynamic from 'next/dynamic';
import pckg from '../../package.json';
import { useContainer, useCytoViewport, useFocusMethods, useInsertingCytoStore, useLayout, useRefAutofill, useShowExtra, useShowTypes, useSpaceId, useLayoutAnimation } from '../hooks';
import { Refstater } from '../refstater';
import { CytoDropZone } from './drop-zone';
import { CytoEditor } from './editor';
import { useCytoElements } from './elements';
import { CytoReactLayout } from './react';
import { useCytoStylesheets } from './stylesheets';
import { useCyInitializer } from './hooks';
import { CytoHandlers, useCytoHandlers, useCytoHandlersApply } from '../cyto-handler';
const CytoscapeComponent = dynamic(() => import('react-cytoscapejs').then((m) => m.default), { ssr: false });
cytoscape.use(dagre);
cytoscape.use(cola);
cytoscape.use(d3Force);
cytoscape.use(deepd3Force);
cytoscape.use(cxtmenu);
cytoscape.use(edgeConnections);
cytoscape.use(edgehandles);
export function useCytoFocusMethods(cy) {
    const { focus, unfocus } = useFocusMethods();
    const lockingRef = useRef({});
    return {
        lockingRef,
        focus: (elOrEl, position) => __awaiter(this, void 0, void 0, function* () {
            var _a;
            if (typeof (elOrEl) === 'number') {
                return yield focus(elOrEl, position);
            }
            else {
                const el = elOrEl;
                const id = (_a = el === null || el === void 0 ? void 0 : el.data('link')) === null || _a === void 0 ? void 0 : _a.id;
                const locking = lockingRef.current;
                if (id) {
                    locking[id] = true;
                    el.lock();
                    const focused = yield focus(id, position);
                    return focused;
                }
            }
        }),
        unfocus: (elOrEl) => __awaiter(this, void 0, void 0, function* () {
            var _b;
            if (typeof (elOrEl) === 'number') {
                return yield unfocus(elOrEl);
            }
            else {
                const el = elOrEl;
                const locking = lockingRef.current;
                const id = (_b = el === null || el === void 0 ? void 0 : el.data('link')) === null || _b === void 0 ? void 0 : _b.id;
                if (id) {
                    el.unlock();
                    locking[id] = false;
                    const focused = yield unfocus(id);
                    return focused;
                }
            }
        })
    };
}
export default function CytoGraph({ links = [], cytoViewportRef, cyRef, gqlPath, gqlSsl, appVersion = '', }) {
    var _a, _b, _c, _d;
    const deep = useDeep();
    const [spaceId, setSpaceId] = useSpaceId();
    const [container, setContainer] = useContainer();
    const [extra, setExtra] = useShowExtra();
    const [showTypes, setShowTypes] = useShowTypes();
    const [insertingCyto, setInsertingCyto] = useInsertingCytoStore();
    const insertingCytoRef = useRefAutofill(insertingCyto);
    const toast = useToast();
    const [cy, setCy] = useState();
    cyRef.current = cy;
    const ehRef = useRef();
    const cyh = useCytoHandlers();
    const { cytoHandlersRef, iterator, onChange } = cyh;
    const stylesheets = useCytoStylesheets();
    const { elementsById, elements, reactElements, cytoHandled } = useCytoElements(deep.minilinks, links, cy, spaceId, cyh);
    const elementsRef = useRefAutofill(elements);
    const newStylesheets = [];
    useCytoHandlersApply(cyh, elements, newStylesheets, iterator);
    const resultStylesheets = [...stylesheets, ...newStylesheets];
    const { onLoaded } = useCyInitializer({
        elementsRef, elements, reactElements, cyRef, setCy, ehRef, cytoViewportRef
    });
    const { layout, setLayout } = useLayout();
    const [layoutAnimation] = useLayoutAnimation();
    const returning = (_jsxs(_Fragment, { children: [_jsx(CytoHandlers, { handled: cytoHandled, elementsById: elementsById, onChange: onChange }), _jsx(Refstater, { useHook: useCytoViewport, stateRef: cytoViewportRef }), _jsxs("div", { style: { position: 'absolute', top: 0, left: 0, width: '100%', height: '100%' }, children: [_jsxs(CytoDropZone, { cy: cy, gqlPath: gqlPath, gqlSsl: gqlSsl, children: [_jsx(CytoscapeComponent, { cy: (_cy) => {
                                    if (!cy)
                                        onLoaded(_cy);
                                }, elements: elements, layout: layout({ elementsRef: elementsRef.current, cy, isAnimate: layoutAnimation, deep }), stylesheet: resultStylesheets, panningEnabled: true, pan: (_b = (_a = cytoViewportRef === null || cytoViewportRef === void 0 ? void 0 : cytoViewportRef.current) === null || _a === void 0 ? void 0 : _a.value) === null || _b === void 0 ? void 0 : _b.pan, zoom: (_d = (_c = cytoViewportRef === null || cytoViewportRef === void 0 ? void 0 : cytoViewportRef.current) === null || _c === void 0 ? void 0 : _c.value) === null || _d === void 0 ? void 0 : _d.zoom, style: { width: '100%', height: '100vh' } }), !!cy && _jsx(CytoReactLayout, { cy: cy, elements: reactElements }), _jsx(CytoEditor, {})] }), _jsxs(Text, { position: "fixed", left: 0, bottom: 0, p: 4, children: ["$", appVersion, " (", pckg.version, ")"] })] })] }));
    return returning;
}
//# sourceMappingURL=graph.js.map