var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import { Alert, AlertIcon, Flex, IconButton, Popover, PopoverContent, PopoverTrigger, SlideFade, Spacer, Spinner, useDisclosure, useToast } from "@chakra-ui/react";
import { useDeep, useDeepId } from "@deep-foundation/deeplinks/imports/client";
import { useMinilinksFilter } from "@deep-foundation/deeplinks/imports/minilinks";
import { useState, useMemo, useCallback, useEffect, useRef } from "react";
import { useHotkeys } from "react-hotkeys-hook";
import { VscChromeClose, VscVersions } from "react-icons/vsc";
import { BsArrowsFullscreen, BsCheck2 } from "react-icons/bs";
import { ClientHandler } from "../client-handler";
import { CytoReactLinksCard } from "../cyto-react-links-card";
import { useContainer, useInsertingCytoStore, useUpdatingCytoStore, useLayout, useRefAutofill, useShowExtra, useShowTypes, useSpaceId, useAutoFocusOnInsert } from "../hooks";
import { CatchErrors } from "../react-errors";
import { useEditorTabs } from "./editor";
import { useCytoFocusMethods } from "./graph";
import { useQueryStore } from '@deep-foundation/store/query';
import { initializeTraveler } from "./traveler";
;
;
const delay = (time) => new Promise(res => setTimeout(res, time));
export function CytoReactLinksCardInsertNode({ insertingLink, setInsertingLink, ml, ehRef, returningRef, insertLinkRef, }) {
    const [search, setSearch] = useState('');
    const deep = useDeep();
    const [insertingCyto, setInsertingCyto] = useInsertingCytoStore();
    const [container, setContainer] = useContainer();
    const [spaceId, setSpaceId] = useSpaceId();
    const { data: Finder } = useDeepId('@deep-foundation/finder', 'Finder');
    const [selectedLink, setSelectedLink] = useState();
    return _jsxs(_Fragment, { children: [!!Finder && _jsx(ClientHandler, { linkId: spaceId, context: [Finder], ml: deep.minilinks, search: '', onChange: l => setSelectedLink(l) }), _jsx(SlideFade, { in: !!selectedLink, offsetX: '-0.5rem', style: { position: 'absolute', bottom: 0, right: '-2.8rem' }, children: _jsx(IconButton, { isRound: true, variant: 'solid', bg: 'primary', "aria-label": 'submit button', icon: _jsx(BsCheck2, {}), onClick: () => __awaiter(this, void 0, void 0, function* () {
                        var _a;
                        if (selectedLink) {
                            deep.minilinks.apply((_a = (yield deep.select({ down: { link_id: { _in: [selectedLink.id, selectedLink.from_id, selectedLink.to_id] } } }))) === null || _a === void 0 ? void 0 : _a.data, 'CytoReactLinksCardInsertNode');
                            if (insertingLink === null || insertingLink === void 0 ? void 0 : insertingLink.alterResolve)
                                insertingLink === null || insertingLink === void 0 ? void 0 : insertingLink.alterResolve(deep.minilinks.byId[selectedLink.id]);
                            setInsertingCyto({});
                            if (!(insertingLink === null || insertingLink === void 0 ? void 0 : insertingLink.alterResolve))
                                returningRef === null || returningRef === void 0 ? void 0 : returningRef.current.startInsertingOfType(selectedLink.id, selectedLink.from_id, selectedLink.to_id);
                            setInsertingLink(undefined);
                        }
                    }) }) })] });
}
;
export function useLinkInserting(elements = [], reactElements = [], focus, cyRef, ehRef) {
    const [insertingLink, setInsertingLink] = useState();
    const [updatingLink, setUpdatingLink] = useState();
    const [container, setContainer] = useContainer();
    const containerRef = useRefAutofill(container);
    const [spaceId, setSpaceId] = useSpaceId();
    const spaceIdRef = useRefAutofill(spaceId);
    const deep = useDeep();
    const deepRef = useRefAutofill(deep);
    const [insertingCyto, setInsertingCyto] = useInsertingCytoStore();
    const [updatingCyto, setUpdatingCyto] = useUpdatingCytoStore();
    const insertingCytoRef = useRefAutofill(insertingCyto);
    const updatingCytoRef = useRefAutofill(updatingCyto);
    const toast = useToast();
    const ml = deep.minilinks;
    useHotkeys('esc', e => {
        e.preventDefault();
        e.stopPropagation();
        if (insertingCyto === null || insertingCyto === void 0 ? void 0 : insertingCyto.type_id) {
            setInsertingCyto(undefined);
        }
    }, { enableOnFormTags: ["TEXTAREA", "INPUT"] });
    const types = useMinilinksFilter(ml, useCallback(() => true, []), useCallback((l, ml) => (ml.links.filter(l => l._applies.includes('insertable-types'))), [])) || [];
    const [autoFocus, setAutoFocus] = useAutoFocusOnInsert();
    const autoFocusRef = useRefAutofill(autoFocus);
    const insertLink = useCallback((type_id, from, to, position) => __awaiter(this, void 0, void 0, function* () {
        var _a, _b;
        const loadedLink = types === null || types === void 0 ? void 0 : types.find(t => t.id === type_id);
        const valued = (_b = (_a = loadedLink === null || loadedLink === void 0 ? void 0 : loadedLink.valued) === null || _a === void 0 ? void 0 : _a[0]) === null || _b === void 0 ? void 0 : _b.to_id;
        const inArray = [];
        if (position && autoFocusRef.current && !from && !to) {
            console.log('insertLink2', type_id, from, to, position, autoFocusRef.current);
            inArray.push(Object.assign({ from_id: spaceIdRef.current, type_id: deep.idLocal('@deep-foundation/core', 'Focus'), object: { data: { value: position } } }, (containerRef.current ? { in: { data: {
                        type_id: deep.idLocal('@deep-foundation/core', 'Contain'),
                        from_id: containerRef.current
                    } } } : {})));
        }
        if (container && type_id !== deep.idLocal('@deep-foundation/core', 'Contain')) {
            inArray.push({
                from_id: container,
                type_id: deep.idLocal('@deep-foundation/core', 'Contain'),
            });
        }
        const { data: [{ id: linkId }] } = yield deep.insert(Object.assign(Object.assign(Object.assign({ type_id: type_id }, (valued === deep.idLocal('@deep-foundation/core', 'String') ? { string: { data: { value: '' } } } :
            valued === deep.idLocal('@deep-foundation/core', 'Number') ? { number: { data: { value: 0 } } } :
                valued === deep.idLocal('@deep-foundation/core', 'Object') ? { object: { data: { value: {} } } } :
                    {})), (!!inArray.length ? { in: { data: inArray } } : {})), { from_id: from || 0, to_id: to || 0 }));
    }), [cyRef.current, types, container, deep.linkId]);
    const insertLinkRef = useRefAutofill(insertLink);
    const updateLink = useCallback((id, from, to, position) => __awaiter(this, void 0, void 0, function* () {
        const { data: [{ id: linkId }] } = yield deep.update(id, {
            from_id: from || 0,
            to_id: to || 0,
        });
    }), [cyRef.current, types, container, deep.linkId]);
    const updateLinkRef = useRefAutofill(updateLink);
    const TempComponent = useMemo(() => {
        return () => _jsx(CytoReactLinksCardInsertNode, { insertingLink: insertingLink, setInsertingLink: setInsertingLink, ml: ml, ehRef: ehRef, returningRef: returningRef, insertLinkRef: insertLinkRef });
    }, [insertingLink]);
    if (insertingLink) {
        const element = {
            id: 'insert-link-card',
            position: insertingLink.position,
            locked: true,
            classes: 'insert-link-card',
            data: {
                id: 'insert-link-card',
                Component: TempComponent,
            },
        };
        elements.push(element);
        reactElements.push(element);
    }
    useHotkeys('esc', () => {
        var _a, _b, _c, _d;
        if ((_a = insertingCytoRef === null || insertingCytoRef === void 0 ? void 0 : insertingCytoRef.current) === null || _a === void 0 ? void 0 : _a.type_id)
            setInsertingCyto({});
        (_b = ehRef === null || ehRef === void 0 ? void 0 : ehRef.current) === null || _b === void 0 ? void 0 : _b.disableDrawMode();
        (_d = (_c = cyRef.current) === null || _c === void 0 ? void 0 : _c.$('.eh-ghost,.eh-preview')) === null || _d === void 0 ? void 0 : _d.remove();
    });
    const returning = {
        openSearchCard: (searchLink) => {
            if (searchLink) {
                setInsertingLink(searchLink);
                if (cyRef.current) {
                    const el = cyRef.current.$('#insert-link-card');
                    el.unlock();
                    if (!searchLink.from && !searchLink.to) {
                        el.position(searchLink.position);
                        el.lock();
                    }
                }
            }
            else {
                setInsertingLink(undefined);
            }
        },
        insertLink,
        openInsertCard: (insertedLink) => {
            if (insertedLink) {
                setInsertingLink(insertedLink);
                if (cyRef.current) {
                    const el = cyRef.current.$('#insert-link-card');
                    el.unlock();
                    if (!insertedLink.from && !insertedLink.to) {
                        el.position(insertedLink.position);
                        el.lock();
                    }
                }
            }
            else {
                setInsertingLink(undefined);
            }
        },
        insertingCytoRef,
        insertingCyto,
        startUpdatingLink: (id) => {
            var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u;
            const link = ml.byId[id];
            const linkName = ((_d = (_c = (_b = (_a = link === null || link === void 0 ? void 0 : link.inByType) === null || _a === void 0 ? void 0 : _a[deep.idLocal('@deep-foundation/core', 'Contain')]) === null || _b === void 0 ? void 0 : _b[0]) === null || _c === void 0 ? void 0 : _c.value) === null || _d === void 0 ? void 0 : _d.value) || (link === null || link === void 0 ? void 0 : link.id);
            const Type = link.type;
            const TypeName = ((_h = (_g = (_f = (_e = Type === null || Type === void 0 ? void 0 : Type.inByType) === null || _e === void 0 ? void 0 : _e[deep.idLocal('@deep-foundation/core', 'Contain')]) === null || _f === void 0 ? void 0 : _f[0]) === null || _g === void 0 ? void 0 : _g.value) === null || _h === void 0 ? void 0 : _h.value) || (Type === null || Type === void 0 ? void 0 : Type.id);
            const FromName = ((_o = (_m = (_l = (_k = (_j = ml.byId[Type.from_id]) === null || _j === void 0 ? void 0 : _j.inByType) === null || _k === void 0 ? void 0 : _k[deep.idLocal('@deep-foundation/core', 'Contain')]) === null || _l === void 0 ? void 0 : _l[0]) === null || _m === void 0 ? void 0 : _m.value) === null || _o === void 0 ? void 0 : _o.value) || Type.from_id;
            const ToName = ((_t = (_s = (_r = (_q = (_p = ml.byId[Type.to_id]) === null || _p === void 0 ? void 0 : _p.inByType) === null || _q === void 0 ? void 0 : _q[deep.idLocal('@deep-foundation/core', 'Contain')]) === null || _r === void 0 ? void 0 : _r[0]) === null || _s === void 0 ? void 0 : _s.value) === null || _t === void 0 ? void 0 : _t.value) || Type.to_id;
            const t = toast({
                title: `Updating link: ${linkName} type of: ${TypeName}`,
                position: 'bottom-left',
                duration: null,
                icon: _jsx(Spinner, {}),
                isClosable: true,
                onCloseComplete: () => {
                    var _a, _b, _c, _d;
                    if ((_a = updatingCytoRef === null || updatingCytoRef === void 0 ? void 0 : updatingCytoRef.current) === null || _a === void 0 ? void 0 : _a.id)
                        setUpdatingCyto({});
                    (_b = ehRef === null || ehRef === void 0 ? void 0 : ehRef.current) === null || _b === void 0 ? void 0 : _b.disableDrawMode();
                    (_d = (_c = cyRef.current) === null || _c === void 0 ? void 0 : _c.$('.eh-ghost,.eh-preview')) === null || _d === void 0 ? void 0 : _d.remove();
                },
            });
            (_u = ehRef === null || ehRef === void 0 ? void 0 : ehRef.current) === null || _u === void 0 ? void 0 : _u.enableDrawMode();
            setUpdatingLink(undefined);
            setUpdatingCyto({ id, toast: t });
        },
        startInsertingOfType: (id, From, To) => {
            var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q;
            const link = ml.byId[id];
            const isNode = !From && !To;
            const isPossibleNode = isNode || (From === To && From === deep.idLocal('@deep-foundation/core', 'Any'));
            const TypeName = ((_d = (_c = (_b = (_a = link === null || link === void 0 ? void 0 : link.inByType) === null || _a === void 0 ? void 0 : _a[deep.idLocal('@deep-foundation/core', 'Contain')]) === null || _b === void 0 ? void 0 : _b[0]) === null || _c === void 0 ? void 0 : _c.value) === null || _d === void 0 ? void 0 : _d.value) || (link === null || link === void 0 ? void 0 : link.id);
            const FromName = ((_j = (_h = (_g = (_f = (_e = ml.byId[From]) === null || _e === void 0 ? void 0 : _e.inByType) === null || _f === void 0 ? void 0 : _f[deep.idLocal('@deep-foundation/core', 'Contain')]) === null || _g === void 0 ? void 0 : _g[0]) === null || _h === void 0 ? void 0 : _h.value) === null || _j === void 0 ? void 0 : _j.value) || From;
            const ToName = ((_p = (_o = (_m = (_l = (_k = ml.byId[To]) === null || _k === void 0 ? void 0 : _k.inByType) === null || _l === void 0 ? void 0 : _l[deep.idLocal('@deep-foundation/core', 'Contain')]) === null || _m === void 0 ? void 0 : _m[0]) === null || _o === void 0 ? void 0 : _o.value) === null || _p === void 0 ? void 0 : _p.value) || To;
            const t = toast({
                title: `Inserting link type of: ${TypeName}`,
                description: `This ${isNode ? `is node type, just click somewhere for insert.` : `is link type, connect two links from typeof ${FromName} to typeof ${ToName} for insert.`}`,
                position: 'bottom-left',
                duration: null,
                icon: _jsx(Spinner, {}),
                isClosable: true,
                onCloseComplete: () => {
                    var _a, _b, _c, _d;
                    if ((_a = insertingCytoRef === null || insertingCytoRef === void 0 ? void 0 : insertingCytoRef.current) === null || _a === void 0 ? void 0 : _a.type_id)
                        setInsertingCyto({});
                    (_b = ehRef === null || ehRef === void 0 ? void 0 : ehRef.current) === null || _b === void 0 ? void 0 : _b.disableDrawMode();
                    (_d = (_c = cyRef.current) === null || _c === void 0 ? void 0 : _c.$('.eh-ghost,.eh-preview')) === null || _d === void 0 ? void 0 : _d.remove();
                },
            });
            if (!isNode) {
                (_q = ehRef === null || ehRef === void 0 ? void 0 : ehRef.current) === null || _q === void 0 ? void 0 : _q.enableDrawMode();
            }
            setInsertingLink(undefined);
            setInsertingCyto({ isNode, isPossibleNode, type_id: id, toast: t, From, To });
        },
        drawendInserting: (position, from, to) => {
            var _a;
            const ins = insertingCytoRef.current;
            setInsertingCyto({});
            toast.close(ins.toast);
            (_a = ehRef === null || ehRef === void 0 ? void 0 : ehRef.current) === null || _a === void 0 ? void 0 : _a.disableDrawMode();
            cyRef.current.$('.eh-ghost,.eh-preview').remove();
            if (ins.type_id) {
                insertLinkRef.current(ins.type_id, +from, +to, position);
            }
            else {
                returning.openInsertCard({
                    position, from, to
                });
            }
        },
        drawendUpdating: (position, from, to) => {
            var _a;
            const upd = updatingCytoRef.current;
            setUpdatingCyto({});
            toast.close(upd.toast);
            (_a = ehRef === null || ehRef === void 0 ? void 0 : ehRef.current) === null || _a === void 0 ? void 0 : _a.disableDrawMode();
            cyRef.current.$('.eh-ghost,.eh-preview').remove();
            updateLinkRef.current(upd.id, +from, +to, position);
        },
    };
    const returningRef = useRefAutofill(returning);
    const cyHandledRef = useRef(false);
    useEffect(() => {
        if (!cyRef.current || cyHandledRef.current)
            return;
        cyHandledRef.current = true;
        const ehstop = (event, sourceNode, targetNode, addedEdge) => __awaiter(this, void 0, void 0, function* () {
            var _a;
            let { position } = event;
            addedEdge === null || addedEdge === void 0 ? void 0 : addedEdge.remove();
            (_a = ehRef === null || ehRef === void 0 ? void 0 : ehRef.current) === null || _a === void 0 ? void 0 : _a.disableDrawMode();
            if (insertingCytoRef.current.type_id) {
                const ins = insertingCytoRef.current;
                if ((sourceNode === null || sourceNode === void 0 ? void 0 : sourceNode.id()) && !(targetNode === null || targetNode === void 0 ? void 0 : targetNode.id()) && ins._selfLink !== false) {
                    ins.from = +(sourceNode === null || sourceNode === void 0 ? void 0 : sourceNode.id());
                    ins.to = +(targetNode === null || targetNode === void 0 ? void 0 : targetNode.id());
                    ins._selfLink = true;
                    setInsertingCyto(Object.assign(Object.assign({}, ins), { from: +(sourceNode === null || sourceNode === void 0 ? void 0 : sourceNode.id()), to: +(sourceNode === null || sourceNode === void 0 ? void 0 : sourceNode.id()), _selfLink: true }));
                }
                else {
                    setInsertingCyto({});
                }
                toast.close(ins.toast);
            }
            else if (updatingCytoRef.current.id) {
                const upd = updatingCytoRef.current;
                if ((sourceNode === null || sourceNode === void 0 ? void 0 : sourceNode.id()) && !(targetNode === null || targetNode === void 0 ? void 0 : targetNode.id()) && upd._selfLink !== false) {
                    upd.from = +(sourceNode === null || sourceNode === void 0 ? void 0 : sourceNode.id());
                    upd.to = +(targetNode === null || targetNode === void 0 ? void 0 : targetNode.id());
                    if ((sourceNode === null || sourceNode === void 0 ? void 0 : sourceNode.id()) === updatingCytoRef.current.id) {
                        upd._selfLink = true;
                        setUpdatingCyto(Object.assign(Object.assign({}, upd), { from: 0, to: 0, _selfLink: true }));
                    }
                    else {
                        returning.drawendUpdating(position, upd.from, upd.from);
                    }
                }
                toast.close(upd.toast);
            }
        });
        const ehcomplete = (event, sourceNode, targetNode, addedEdge) => __awaiter(this, void 0, void 0, function* () {
            var _b, _c, _d, _e;
            let { position } = event;
            if (insertingCytoRef.current.type_id) {
                insertingCytoRef.current._selfLink = false;
                addedEdge === null || addedEdge === void 0 ? void 0 : addedEdge.remove();
                const from = (_b = sourceNode === null || sourceNode === void 0 ? void 0 : sourceNode.data('link')) === null || _b === void 0 ? void 0 : _b.id;
                const to = (_c = targetNode === null || targetNode === void 0 ? void 0 : targetNode.data('link')) === null || _c === void 0 ? void 0 : _c.id;
                if (from && to)
                    returning.drawendInserting(position, from, to);
            }
            else if (updatingCytoRef.current.id) {
                updatingCytoRef.current._selfLink = false;
                addedEdge === null || addedEdge === void 0 ? void 0 : addedEdge.remove();
                const from = (_d = sourceNode === null || sourceNode === void 0 ? void 0 : sourceNode.data('link')) === null || _d === void 0 ? void 0 : _d.id;
                const to = (_e = targetNode === null || targetNode === void 0 ? void 0 : targetNode.data('link')) === null || _e === void 0 ? void 0 : _e.id;
                if (from && to)
                    returning.drawendUpdating(position, from, to);
            }
        });
        const tap = function (event) {
            var _a, _b;
            return __awaiter(this, void 0, void 0, function* () {
                (_a = ehRef === null || ehRef === void 0 ? void 0 : ehRef.current) === null || _a === void 0 ? void 0 : _a.disableDrawMode();
                setInsertingLink(undefined);
                if (insertingCytoRef.current.type_id) {
                    const ins = insertingCytoRef.current;
                    setInsertingCyto({});
                    toast.close(ins.toast);
                    if (event.target === cyRef.current) {
                        if (ins.type_id) {
                            if (ins.isPossibleNode) {
                                yield returningRef.current.insertLink(ins.type_id, 0, 0, event.position);
                                toast.close(ins.toast);
                                setInsertingCyto({});
                            }
                            else {
                                const Any = deep.idLocal('@deep-foundation/core', 'Any');
                                if (ins.From === Any && ins.To === Any) {
                                    yield returningRef.current.insertLink(ins.type_id, 0, 0, ins === null || ins === void 0 ? void 0 : ins.position);
                                }
                                setInsertingCyto({});
                            }
                        }
                        (_b = returningRef.current) === null || _b === void 0 ? void 0 : _b.openInsertCard(undefined);
                    }
                }
            });
        };
        cyRef.current.on('ehstop', ehstop);
        cyRef.current.on('ehcomplete', ehcomplete);
        cyRef.current.on('tap', tap);
        return () => {
            cyRef.current.removeListener('ehstop', ehstop);
            cyRef.current.removeListener('ehcomplete', ehcomplete);
            cyRef.current.removeListener('tap', tap);
        };
    }, [cyRef.current]);
    return returning;
}
export function useLinkReactElements(elements = [], reactElements = [], cy, ml) {
    const [linkReactElements, setLinkReactElements] = useState({});
    const linkReactElementsIds = useMemo(() => Object.keys(linkReactElements).filter(key => !!linkReactElements[key]), [linkReactElements]).map(key => parseInt(key), [linkReactElements]);
    reactElements.push(...linkReactElementsIds.map(id => (elements.find(e => e.id === id))));
    const cyRef = useRefAutofill(cy);
    const toggleLinkReactElement = (id) => {
        setLinkReactElements((linkReactElements) => {
            const cy = cyRef.current;
            const isEnabling = !linkReactElements[id];
            if (isEnabling) {
                cy === null || cy === void 0 ? void 0 : cy.$(`#${id}`).data('Component', AnyLinkComponent);
                cy === null || cy === void 0 ? void 0 : cy.$(`#${id}`).addClass('unhoverable').removeClass('hover');
            }
            else {
                cy === null || cy === void 0 ? void 0 : cy.$(`#${id}`).data('Component', undefined);
                cy === null || cy === void 0 ? void 0 : cy.$(`#${id}`).removeClass('unhoverable');
            }
            return Object.assign(Object.assign({}, linkReactElements), { [id]: !linkReactElements[id] });
        });
    };
    const AnyLinkComponent = useMemo(() => {
        return function AnyLinkComponent({ id }) {
            const deep = useDeep();
            const [handlerId, setHandlerId] = useState();
            const { onOpen, onClose, isOpen } = useDisclosure();
            const [search, setSearch] = useState('');
            const [spaceId] = useSpaceId();
            const { data: handleClients } = deep.useDeepQuery({
                type_id: deep.idLocal('@deep-foundation/core', 'HandleClient'),
                from: {
                    down: {
                        tree_id: { _eq: deep.idLocal('@deep-foundation/core', 'typesTree') },
                        link_id: { _eq: id },
                    },
                }
            });
            useEffect(() => {
                if (!handlerId) {
                    const inheritance = [];
                    for (let pointer = deep.minilinks.byId[id]; !!pointer && inheritance[inheritance.length - 1] !== pointer; pointer = pointer === null || pointer === void 0 ? void 0 : pointer.type) {
                        inheritance.push(pointer);
                        const handleClient = handleClients.find(h => h.from_id === pointer.id);
                        if (handleClient) {
                            setHandlerId(handleClient === null || handleClient === void 0 ? void 0 : handleClient.to_id);
                            break;
                        }
                    }
                }
            }, [handleClients]);
            const handleClient = handleClients.find(h => h.to_id === handlerId);
            const elements = (handleClients === null || handleClients === void 0 ? void 0 : handleClients.map(t => {
                var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r;
                return ({
                    id: t === null || t === void 0 ? void 0 : t.to_id,
                    src: ((_e = (_d = (_c = (_b = (_a = deep.minilinks.byId) === null || _a === void 0 ? void 0 : _a[t === null || t === void 0 ? void 0 : t.to_id]) === null || _b === void 0 ? void 0 : _b.inByType[deep.idLocal('@deep-foundation/core', 'Symbol')]) === null || _c === void 0 ? void 0 : _c[0]) === null || _d === void 0 ? void 0 : _d.value) === null || _e === void 0 ? void 0 : _e.value) || t.id,
                    linkName: ((_k = (_j = (_h = (_g = (_f = deep.minilinks.byId) === null || _f === void 0 ? void 0 : _f[t === null || t === void 0 ? void 0 : t.to_id]) === null || _g === void 0 ? void 0 : _g.inByType[deep.idLocal('@deep-foundation/core', 'Contain')]) === null || _h === void 0 ? void 0 : _h[0]) === null || _j === void 0 ? void 0 : _j.value) === null || _k === void 0 ? void 0 : _k.value) || t.id,
                    containerName: ((_r = (_q = (_p = (_o = (_m = (_l = deep.minilinks.byId) === null || _l === void 0 ? void 0 : _l[t === null || t === void 0 ? void 0 : t.to_id]) === null || _m === void 0 ? void 0 : _m.inByType[deep.idLocal('@deep-foundation/core', 'Contain')]) === null || _o === void 0 ? void 0 : _o[0]) === null || _p === void 0 ? void 0 : _p.from) === null || _q === void 0 ? void 0 : _q.value) === null || _r === void 0 ? void 0 : _r.value) || '',
                });
            })) || [];
            const onCloseCard = useCallback(() => toggleLinkReactElement(id), [id]);
            return _jsx("div", { children: _jsxs(CatchErrors, { errorRenderer: (error, reset) => {
                        return _jsx("div", { children: String(error) });
                    }, children: [_jsxs(Flex, { mb: '0.25rem', minW: '7rem', children: [_jsxs(Popover, { isLazy: true, isOpen: isOpen, onOpen: onOpen, onClose: onClose, placement: 'right-start', children: [_jsx(PopoverTrigger, { children: _jsx(IconButton, { "aria-label": 'replay to message button', isRound: true, bg: 'whiteGray', borderColor: 'borderColor', borderWidth: 'thin', size: 'xs', sx: {
                                                    marginRight: '0.5rem',
                                                    _hover: {
                                                        transform: 'scale(1.2)',
                                                    }
                                                }, icon: _jsx(VscVersions, {}) }) }), _jsx(PopoverContent, { h: 72, children: _jsx(CytoReactLinksCard, { selectedLinkId: handlerId, elements: elements.filter(el => { var _a, _b, _c, _d, _e, _f; return (!!((_a = el === null || el === void 0 ? void 0 : el.linkName) === null || _a === void 0 ? void 0 : _a.includes) && ((_c = (_b = el === null || el === void 0 ? void 0 : el.linkName) === null || _b === void 0 ? void 0 : _b.toLocaleLowerCase()) === null || _c === void 0 ? void 0 : _c.includes(search)) || ((_d = el === null || el === void 0 ? void 0 : el.containerName) === null || _d === void 0 ? void 0 : _d.includes) && ((_f = (_e = el === null || el === void 0 ? void 0 : el.containerName) === null || _e === void 0 ? void 0 : _e.toLocaleLowerCase()) === null || _f === void 0 ? void 0 : _f.includes(search))); }), search: search, onSearch: e => setSearch(e.target.value), onSubmit: (id) => __awaiter(this, void 0, void 0, function* () {
                                                    setHandlerId(id);
                                                    onClose();
                                                }), fillSize: true }) })] }), _jsx(IconButton, { isRound: true, "aria-label": 'open new full tab', size: 'xs', as: 'a', bg: 'whiteGray', borderColor: 'borderColor', borderWidth: 'thin', target: '_blank', href: `/client-handler?props=%7B"linkId"%3A${id}%2C"handlerId"%3A${handlerId}%7D`, sx: {
                                        _hover: {
                                            transform: 'scale(1.2)',
                                        }
                                    }, icon: _jsx(BsArrowsFullscreen, {}) }), _jsx(Spacer, {}), _jsx(IconButton, { isRound: true, "aria-label": 'close client handler', size: 'xs', bg: 'whiteGray', borderColor: 'borderColor', borderWidth: 'thin', sx: {
                                        _hover: {
                                            transform: 'scale(1.2)',
                                        }
                                    }, icon: _jsx(VscChromeClose, {}), onClick: onCloseCard })] }), !(handleClient === null || handleClient === void 0 ? void 0 : handleClient.to_id) && _jsxs(Alert, { status: 'error', children: [_jsx(AlertIcon, {}), "Compatible HandleClient not found."] }), !!(handleClient === null || handleClient === void 0 ? void 0 : handleClient.to_id) && [_jsx(ClientHandler, { handlerId: handleClient === null || handleClient === void 0 ? void 0 : handleClient.to_id, linkId: id, ml: ml, onClose: onCloseCard }, `${id}${handleClient === null || handleClient === void 0 ? void 0 : handleClient.to_id}`)]] }) });
        };
    }, [cy]);
    return {
        toggleLinkReactElement,
        linkReactElements: linkReactElementsIds,
    };
}
export function useCytoEditor() {
    return useQueryStore('cyto-editor', false);
}
export function useCyInitializer({ elementsRef, elements, reactElements, cyRef, setCy, ehRef, cytoViewportRef, }) {
    const deep = useDeep();
    const { layout, setLayout } = useLayout();
    const [extra, setExtra] = useShowExtra();
    const [spaceId, setSpaceId] = useSpaceId();
    const [container, setContainer] = useContainer();
    const [showTypes, setShowTypes] = useShowTypes();
    const [cytoEditor, setCytoEditor] = useCytoEditor();
    const [autoFocus, setAutoFocus] = useAutoFocusOnInsert();
    const autoFocusRef = useRefAutofill(autoFocus);
    const containerRef = useRefAutofill(container);
    const ml = deep.minilinks;
    const spaceIdRef = useRefAutofill(spaceId);
    const deepRef = useRefAutofill(deep);
    const { addTab, activeTab, } = useEditorTabs();
    const refDragStartedEvent = useRef();
    const { linkReactElements, toggleLinkReactElement } = useLinkReactElements(elements, reactElements, cyRef.current, ml);
    const { focus, unfocus, lockingRef } = useCytoFocusMethods(cyRef.current);
    const { startInsertingOfType, startUpdatingLink, openInsertCard, insertLink, drawendInserting, insertingCyto, insertingCytoRef } = useLinkInserting(elements, reactElements, focus, cyRef, ehRef);
    const onLoaded = (ncy) => {
        const locking = lockingRef.current;
        let eh = ehRef.current = ncy.edgehandles({
            hoverDelay: 150,
            snap: true,
            snapThreshold: 0,
            snapFrequency: 15,
            noEdgeEventsInDraw: true,
            disableBrowserGestures: true
        });
        const layoutstart = () => {
        };
        const layoutstop = () => {
        };
        const mouseover = function (e) {
            var _a;
            var node = e.target;
            if (!node.is(':parent')) {
                const id = (_a = node === null || node === void 0 ? void 0 : node.data('link')) === null || _a === void 0 ? void 0 : _a.id;
                if (id) {
                    ncy.$(`node, edge`).not(`#${id},#${id}-from,#${id}-to,#${id}-type`).removeClass('hover');
                    ncy.$(`#${id},#${id}-from,#${id}-to,#${id}-type`).not(`.unhoverable`).addClass('hover');
                }
                if (node.locked()) {
                    node.mouseHoverDragging = true;
                }
            }
        };
        const mouseout = function (e) {
            var _a;
            var node = e.target;
            if (!node.is(':parent')) {
                const id = (_a = node === null || node === void 0 ? void 0 : node.data('link')) === null || _a === void 0 ? void 0 : _a.id;
                if (id) {
                    ncy.$(`node, edge`).removeClass('hover');
                }
                if (node.mouseHoverDragging) {
                    node.mouseHoverDragging = false;
                }
            }
        };
        const click = function (e) {
            var _a;
            var node = e.target;
            const id = (_a = node === null || node === void 0 ? void 0 : node.data('link')) === null || _a === void 0 ? void 0 : _a.id;
            if (id) {
                toggleLinkReactElement(id);
            }
        };
        const tapstart = function (evt) {
            var node = evt.target;
            refDragStartedEvent.current = evt;
        };
        let dragendData = undefined;
        const tapend = function (evt) {
            var node = evt.target;
            refDragStartedEvent.current = undefined;
            dragendData = { position: evt.position };
            evt.target.emit('dragend');
        };
        const dragend = function (evt) {
            var _a;
            return __awaiter(this, void 0, void 0, function* () {
                var node = evt.target;
                const id = (_a = node === null || node === void 0 ? void 0 : node.data('link')) === null || _a === void 0 ? void 0 : _a.id;
                const ins = insertingCytoRef.current;
                if ((ins === null || ins === void 0 ? void 0 : ins.from) && !(ins === null || ins === void 0 ? void 0 : ins.to) && ins._selfLink) {
                    yield deep.insert({
                        type_id: ins.type_id,
                        from_id: ins === null || ins === void 0 ? void 0 : ins.from,
                        to_id: ins === null || ins === void 0 ? void 0 : ins.from,
                        in: { data: [
                                {
                                    from_id: containerRef.current,
                                    type_id: deep.idLocal('@deep-foundation/core', 'Contain'),
                                },
                            ] },
                    });
                }
                else if (id) {
                    focus(node, dragendData === null || dragendData === void 0 ? void 0 : dragendData.position);
                    dragendData = undefined;
                    ncy.$(`#${id},#${id}-from,#${id}-to,#${id}-type`).addClass('focused');
                }
            });
        };
        const nodeMenu = ncy.cxtmenu({
            selector: '.link-node',
            menuRadius: function (ele) { return 108; },
            outsideMenuCancel: 10,
            openMenuEvents: 'cxttapstart taphold ctxmenu-nodeMenu-open',
            closeMenuEvents: 'ctxmenu-nodeMenu-close',
            activeFillColor: 'rgba(0, 128, 255, 0.75)',
            activePadding: 2,
            indicatorSize: 16,
            separatorWidth: 3,
            spotlightPadding: 3,
            adaptativeNodeSpotlightRadius: true,
            commands: [
                {
                    content: 'editor',
                    contentStyle: { fontSize: '0.9rem', transform: 'rotate(70deg)' },
                    select: function (ele) {
                        var _a, _b, _c;
                        const id = (_a = ele.data('link')) === null || _a === void 0 ? void 0 : _a.id;
                        if (id) {
                            addTab({
                                id, saved: true,
                                initialValue: deep.stringify((_c = (_b = ml.byId[id]) === null || _b === void 0 ? void 0 : _b.value) === null || _c === void 0 ? void 0 : _c.value),
                            });
                            activeTab(id);
                            setCytoEditor(true);
                        }
                    }
                },
                {
                    content: 'unlock',
                    contentStyle: { fontSize: '0.9rem', transform: 'rotate(35deg)' },
                    select: function (ele) {
                        var _a;
                        return __awaiter(this, void 0, void 0, function* () {
                            const id = (_a = ele.data('link')) === null || _a === void 0 ? void 0 : _a.id;
                            if (id) {
                                yield unfocus(ele);
                                ncy.$(`#${id},#${id}-from,#${id}-to,#${id}-type`).removeClass('focused');
                            }
                        });
                    }
                },
                {
                    content: 'delete',
                    select: function (ele) {
                        var _a;
                        return __awaiter(this, void 0, void 0, function* () {
                            const id = (_a = ele.data('link')) === null || _a === void 0 ? void 0 : _a.id;
                            if (id) {
                                if (confirm(`Are you shure whant to delete this link?`)) {
                                    yield deep.delete(+id);
                                }
                            }
                        });
                    }
                },
                {
                    content: 'delete down',
                    contentStyle: { fontSize: '0.7rem', transform: 'rotate(-35deg)' },
                    select: function (ele) {
                        var _a;
                        return __awaiter(this, void 0, void 0, function* () {
                            const id = (_a = ele.data('link')) === null || _a === void 0 ? void 0 : _a.id;
                            if (id) {
                                if (confirm(`Are you shure whant to delete all links down by contain tree?`)) {
                                    yield deep.delete({
                                        up: {
                                            tree_id: { _eq: deep.idLocal('@deep-foundation/core', 'containTree') },
                                            parent_id: { _eq: +id },
                                        },
                                    });
                                }
                            }
                        });
                    }
                },
                {
                    ncy,
                    setCy,
                    content: 'insert',
                    contentStyle: { fontSize: '0.9rem', transform: 'rotate(-70deg)' },
                    select: function (ele) {
                        var _a;
                        return __awaiter(this, void 0, void 0, function* () {
                            const id = (_a = ele.data('link')) === null || _a === void 0 ? void 0 : _a.id;
                            if (id) {
                                startInsertingOfType(id, 0, 0);
                            }
                        });
                    }
                },
                {
                    content: 'update',
                    contentStyle: { fontSize: '0.9rem', transform: 'rotate(70deg)' },
                    select: function (ele) {
                        var _a;
                        return __awaiter(this, void 0, void 0, function* () {
                            const id = (_a = ele.data('link')) === null || _a === void 0 ? void 0 : _a.id;
                            if (id) {
                                startUpdatingLink(id);
                            }
                        });
                    },
                },
                {
                    content: 'login',
                    contentStyle: { fontSize: '0.9rem', transform: 'rotate(35deg)' },
                    select: function (ele) {
                        var _a;
                        return __awaiter(this, void 0, void 0, function* () {
                            const id = (_a = ele.data('link')) === null || _a === void 0 ? void 0 : _a.id;
                            if (id) {
                                const { linkId } = yield deep.login({ linkId: +id });
                                if (linkId) {
                                    setSpaceId(+id);
                                    setContainer(+id);
                                }
                            }
                        });
                    }
                },
                {
                    content: 'space',
                    select: function (ele) {
                        var _a;
                        return __awaiter(this, void 0, void 0, function* () {
                            const id = (_a = ele.data('link')) === null || _a === void 0 ? void 0 : _a.id;
                            if (id) {
                                setSpaceId(+id);
                                setContainer(+id);
                            }
                        });
                    }
                },
                {
                    content: 'container',
                    contentStyle: { fontSize: '0.9rem', transform: 'rotate(-35deg)' },
                    select: function (ele) {
                        var _a;
                        return __awaiter(this, void 0, void 0, function* () {
                            const id = (_a = ele.data('link')) === null || _a === void 0 ? void 0 : _a.id;
                            if (id) {
                                setContainer(+id);
                            }
                        });
                    }
                },
                {
                    content: (ele) => { var _a, _b; return `traveler (${((_b = traveler.findTravlers(undefined, (_a = ele.data('link')) === null || _a === void 0 ? void 0 : _a.id)) === null || _b === void 0 ? void 0 : _b.length) || 0})`; },
                    contentStyle: { fontSize: '0.6rem', transform: 'rotate(-70deg)', paddingLeft: '6px' },
                    select: function (ele) {
                        var _a;
                        return __awaiter(this, void 0, void 0, function* () {
                            const id = (_a = ele.data('link')) === null || _a === void 0 ? void 0 : _a.id;
                            if (id) {
                                yield delay(60);
                                ele.emit('ctxmenu-nodeMenu-close');
                                yield delay(60);
                                ele.emit('ctxmenu-travelerMenu-open');
                            }
                        });
                    }
                },
            ]
        });
        const traveler = initializeTraveler(ncy, deepRef, spaceIdRef);
        const bodyMenu = ncy.cxtmenu({
            selector: 'core',
            outsideMenuCancel: 10,
            commands: [
                {
                    content: 'insert',
                    select: function (el, ev) {
                        setTimeout(() => {
                            openInsertCard({ position: ev.position, from: 0, to: 0 });
                        }, 1);
                    }
                },
                {
                    content: 'center',
                    select: function (el, ev) {
                        ncy.pan({ x: window.innerWidth / 2, y: window.innerHeight / 2 });
                        ncy.zoom(1);
                    }
                },
                {
                    content: 'query',
                    select: function (el, ev) {
                        openInsertCard({ position: ev.position, from: 0, to: 0, alterResolve: (link) => __awaiter(this, void 0, void 0, function* () {
                                deep.insert({
                                    type_id: yield deep.id('@deep-foundation/deepcase', 'Traveler'),
                                    from_id: link === null || link === void 0 ? void 0 : link.id,
                                    in: { data: {
                                            type_id: yield deep.id('@deep-foundation/core', 'Contain'),
                                            from_id: spaceId,
                                        } },
                                    to: { data: {
                                            type_id: yield deep.id('@deep-foundation/core', 'Query'),
                                            object: { data: { value: { id: link === null || link === void 0 ? void 0 : link.id } } },
                                            in: { data: [
                                                    {
                                                        type_id: yield deep.id('@deep-foundation/core', 'Contain'),
                                                        from_id: spaceId,
                                                    },
                                                    {
                                                        type_id: yield deep.id('@deep-foundation/core', 'Active'),
                                                        from_id: spaceId,
                                                        in: { data: {
                                                                type_id: yield deep.id('@deep-foundation/core', 'Contain'),
                                                                from_id: spaceId,
                                                            } },
                                                    },
                                                ] },
                                        } },
                                });
                                if (autoFocusRef.current)
                                    focus(link === null || link === void 0 ? void 0 : link.id, ev === null || ev === void 0 ? void 0 : ev.position);
                            }) });
                    }
                },
            ]
        });
        const cxttapstart = function (event) {
            return __awaiter(this, void 0, void 0, function* () {
                ncy.$('.eh-ghost,.eh-preview').remove();
            });
        };
        const updatedListener = (oldLink, newLink) => {
            var _a, _b;
            if (newLink.type_id === deep.idLocal('@deep-foundation/core', 'Focus') && ((_b = (_a = newLink === null || newLink === void 0 ? void 0 : newLink.value) === null || _a === void 0 ? void 0 : _a.value) === null || _b === void 0 ? void 0 : _b.x) &&
                locking[newLink.to_id] !== false) {
                const node = ncy.$(`node#${newLink.to_id}`);
                if (!node.mouseHoverDragging) {
                    node.unlock();
                    node.lock();
                }
            }
        };
        const viewport = (event) => {
            var _a;
            (_a = cytoViewportRef === null || cytoViewportRef === void 0 ? void 0 : cytoViewportRef.current) === null || _a === void 0 ? void 0 : _a.setValue({ pan: ncy.pan(), zoom: ncy.zoom() });
        };
        ncy.on('cxttapstart', cxttapstart);
        ncy.on('dragend', 'node', dragend);
        ncy.on('tapend', 'node', tapend);
        ncy.on('tapstart', 'node', tapstart);
        ncy.on('click', '.link-node, .link', click);
        ncy.on('mouseout', '.link-from, .link-to, .link-type, .link-node', mouseout);
        ncy.on('mouseover', '.link-from, .link-to, .link-type, .link-node', mouseover);
        ncy.on('layoutstart', layoutstart);
        ncy.on('layoutstop', layoutstop);
        ncy.on('viewport', viewport);
        ml.emitter.on('updated', updatedListener);
        setCy(ncy);
        return () => {
            ncy.removeListener('cxttapstart', cxttapstart);
            ncy.removeListener('dragend', 'node', dragend);
            ncy.removeListener('tapend', 'node', tapend);
            ncy.removeListener('tapstart', 'node', tapstart);
            ncy.removeListener('click', '.link-from, .link-to, .link-type, .link-node', click);
            ncy.removeListener('mouseout', '.link-from, .link-to, .link-type, .link-node', mouseout);
            ncy.removeListener('mouseover', '.link-from, .link-to, .link-type, .link-node', mouseover);
            ncy.removeListener('layoutstart', layoutstart);
            ncy.removeListener('layoutstop', layoutstop);
            ncy.removeListener('viewport', viewport);
            ml.emitter.removeListener('updated', updatedListener);
            nodeMenu.destroy();
            bodyMenu.destroy();
            traveler.destroy();
        };
    };
    return {
        onLoaded,
    };
}
export function useCytoHandlersRules() {
    return useQueryStore('ch-rules', {});
}
;
//# sourceMappingURL=hooks.js.map