export const layoutColaPreset = ({ isAnimate = false }) => ({
    name: 'cola',
    animate: false,
    refresh: 10,
    maxSimulationTime: 100,
    ungrabifyWhileSimulating: false,
    fit: false,
    boundingBox: undefined,
    nodeDimensionsIncludeLabels: true,
    ready: function () { },
    stop: function () { },
    randomize: false,
    avoidOverlap: false,
    handleDisconnected: false,
    convergenceThreshold: 0.01,
    nodeSpacing: function (node) { return 10; },
    flow: undefined,
    alignment: undefined,
    gapInequalities: undefined,
    centerGraph: true,
    edgeLength: function (edge) {
        const baseLength = 100;
        const extraLength = 10;
        const sourceNode = edge.source();
        const targetNode = edge.target();
        const sourceConnectedEdges = sourceNode.connectedEdges().length;
        const targetConnectedEdges = targetNode.connectedEdges().length;
        return baseLength + (sourceConnectedEdges + targetConnectedEdges) * extraLength;
    },
    edgeSymDiffLength: undefined,
    edgeJaccardLength: undefined,
    unconstrIter: undefined,
    userConstIter: undefined,
    allConstIter: undefined,
});
export const layoutD3ForcePreset = ({ isAnimate = false, cy, deep }) => ({
    deep: () => deep,
    name: 'deep-d3-force',
    animate: isAnimate,
    maxIterations: 0,
    maxSimulationTime: 0,
    ungrabifyWhileSimulating: false,
    fixedAfterDragging: false,
    fit: false,
    padding: 30,
    boundingBox: undefined,
    alpha: 0.8,
    alphaMin: 0.001,
    alphaDecay: 0.5,
    alphaTarget: 0.1,
    velocityDecay: 0.6,
    linkId: function id(d) {
        return d.id;
    },
    linkDistance: 100,
    manyBodyStrength: -2000,
    xStrength: 0.09,
    xX: 0,
    yStrength: 0.09,
    yY: 0,
    ready: function () { },
    stop: function () { },
    tick: function (progress) { },
    randomize: false,
    infinite: true
});
export const layouts = {
    'cola': layoutColaPreset,
    'deep-d3-force': layoutD3ForcePreset,
};
//# sourceMappingURL=layouts.js.map