var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import { CloseIcon } from "@chakra-ui/icons";
import { Box, Button, ButtonGroup, FormControl, FormLabel, HStack, IconButton, Input, Popover, PopoverArrow, PopoverBody, PopoverCloseButton, PopoverContent, PopoverHeader, PopoverTrigger, Switch, Tag, TagLabel, Text, VStack, StackDivider } from "@chakra-ui/react";
import { useDeep, useDeepId, useDeepSubscription } from "@deep-foundation/deeplinks/imports/client";
import copy from "copy-to-clipboard";
import { AnimatePresence, motion, useAnimation, useCycle } from 'framer-motion';
import React, { useEffect, useState } from "react";
import { HiMenuAlt2, HiCode, HiOutlineEyeOff } from 'react-icons/hi';
import { SlClose } from 'react-icons/sl';
import { Appearance } from "../component-appearance";
import { useAutoFocusOnInsert, useBreadcrumbs, useContainer, useLayout, useMediaQuery, useReserved, useShowExtra, useShowFocus, useShowTypes, useSpaceId, useTraveler, useLayoutAnimation, useCytoHandlersSwitch } from "../hooks";
import { useCytoEditor, useCytoHandlersRules } from "./hooks";
import { variants, buttonVariant, iconVariants, sideVariants, itemVariants } from "./menu-animation-variants";
import { TbArrowRotaryFirstRight } from "react-icons/tb";
const ListLayout = React.memo(({ currentLayout = 'cola', setCurrentLayout, }) => {
    const [open, cycleOpen] = useCycle(false, true);
    return (_jsxs(_Fragment, { children: [_jsx(Box, { position: "relative", sx: { height: 0, width: "10rem" }, children: _jsx(AnimatePresence, { children: open && (_jsx(Box, { as: motion.div, animate: {
                            scale: 1,
                            transition: { duration: 0.3, type: "spring" }
                        }, exit: {
                            scale: 0,
                            y: "2rem",
                            transition: { delay: 0.7, duration: 0.3, type: "spring" }
                        }, sx: {
                            height: "2rem",
                            width: "10rem",
                            top: 0,
                            left: 0,
                            position: "absolute"
                        }, children: _jsxs(Box, { as: motion.ul, initial: "closed", animate: "open", exit: "closed", variants: sideVariants, sx: {
                                borderRadius: "0.5rem",
                                position: "relative",
                                zIndex: 44,
                                background: 'bgColor',
                                listStyle: "none",
                                padding: '0.5rem',
                                height: '4.5rem',
                                overflowY: 'scroll',
                                overscrollBehavior: 'contain',
                                filter: 'drop-shadow(0px 0px 1px #5f6977)',
                                outline: `solid 4px`,
                                outlineColor: 'colorOutline',
                                outlineOffset: '-4px',
                                '&>*:not(:last-child)': {
                                    pt: '0.2rem',
                                    pb: '0.2rem',
                                }
                            }, children: [_jsx(Box, { as: motion.li, whileHover: { scale: 1.05 }, variants: itemVariants, onClick: () => {
                                        setCurrentLayout('cola');
                                        cycleOpen();
                                    }, children: _jsx(Text, { fontSize: 'sm', children: "cola" }) }), _jsx(Box, { as: motion.li, whileHover: { scale: 1.05 }, variants: itemVariants, onClick: () => {
                                        setCurrentLayout('deep-d3-force');
                                        cycleOpen();
                                    }, children: _jsx(Text, { fontSize: 'sm', children: "deep-d3-force" }) })] }) })) }) }), _jsx(Box, { position: "relative", sx: {
                    height: "2rem",
                    width: "max-content",
                }, children: _jsx(Box, { position: "absolute", children: _jsx(Button, { as: motion.button, bg: 'bgColor', onClick: () => cycleOpen(), sx: {
                            height: '2rem',
                            width: '10rem',
                            filter: 'drop-shadow(0px 0px 1px #5f6977)',
                            justifyContent: 'space-between',
                        }, rightIcon: _jsx(Box, { as: motion.div, variants: iconVariants, animate: open ? "open" : "closed", children: _jsx(TbArrowRotaryFirstRight, {}) }), children: _jsx(Text, { fontSize: 'sm', children: currentLayout }) }) }) })] }));
});
const DeepSwitch = React.memo(({ id, isChecked, onChange, }) => {
    return (_jsx(Switch, { id: id, isChecked: isChecked, onChange: onChange, sx: {
            '& > span': {
                background: isChecked == false ? '#8a8989' : 'switchOn'
            },
            '& > span span': {
                background: 'switchThumb'
            }
        } }));
});
export function CytoMenu({ cyRef, gqlPath, gqlSsl, openPortal, }) {
    const [spaceId, setSpaceId] = useSpaceId();
    const [showTypes, setShowTypes] = useShowTypes();
    const [cytoEditor, setCytoEditor] = useCytoEditor();
    const { layout, setLayout, layoutName } = useLayout();
    const [autoFocus, setAutoFocus] = useAutoFocusOnInsert();
    const [pasteError, setPasteError] = useState(false);
    const [valid, setValid] = useState(undefined);
    const [container, setContainer] = useContainer();
    const [extra, setExtra] = useShowExtra();
    const [focus, setFocus] = useShowFocus();
    const [cytoHandlers, setCytoHandlers] = useCytoHandlersSwitch();
    const [traveler, setTraveler] = useTraveler();
    const [reserved, setReserved] = useReserved();
    const [breadcrumbs, setBreadcrumbs] = useBreadcrumbs();
    const [layoutAnimation, setLayoutAnimation] = useLayoutAnimation();
    const deep = useDeep();
    const [max300] = useMediaQuery('(max-width: 300px)');
    const [togglePackager, setTogglePackager] = useState(false);
    const clearFocuses = () => __awaiter(this, void 0, void 0, function* () {
        yield deep.delete({ _or: [{ type_id: deep.idLocal('@deep-foundation/core', 'Focus'), from_id: spaceId }, { type_id: deep.idLocal('@deep-foundation/core', 'Contain'), from_id: spaceId, to: { type_id: deep.idLocal('@deep-foundation/core', 'Focus'), from_id: spaceId } }] });
    });
    const control = useAnimation();
    useEffect(() => {
        if (togglePackager === true) {
            control.start("hide");
        }
        else {
            control.start("show");
        }
    }, [control, togglePackager]);
    useEffect(() => {
        const timer = setTimeout(() => {
            setPasteError(false);
            setValid(undefined);
        }, 3000);
        return () => clearTimeout(timer);
    }, [pasteError, valid]);
    const handlerChangeLayout = (value) => {
        if (!['cola', 'deep-d3-force'].includes(value))
            return;
        if (value !== 'cola' && value !== 'deep-d3-force')
            return;
        setLayout(value);
    };
    const focuses = deep.useMinilinksSubscription({
        type_id: deep.idLocal('@deep-foundation/core', 'Focus'),
        from_id: spaceId,
    });
    return (_jsxs(Box, { left: 0, pos: 'fixed', children: [_jsx(Button, { as: motion.button, variants: buttonVariant, animate: control, colorScheme: 'blue', onClick: () => setTogglePackager(true), pos: 'absolute', left: 4, top: 4, children: _jsx(HiMenuAlt2, {}) }), _jsx(Button, { as: motion.button, variants: buttonVariant, animate: control, colorScheme: 'blue', onClick: () => setCytoEditor(true), pos: 'absolute', left: 20, top: 4, children: _jsx(HiCode, {}) }), _jsx(Button, { as: motion.button, variants: buttonVariant, animate: control, disabled: !(focuses === null || focuses === void 0 ? void 0 : focuses.length), colorScheme: (focuses === null || focuses === void 0 ? void 0 : focuses.length) ? 'blue' : 'gray', onClick: clearFocuses, pos: 'absolute', left: 36, top: 4, children: _jsx(HiOutlineEyeOff, {}) }), _jsx(Appearance, { toggle: togglePackager, variantsAnimation: variants, initial: 'initial', styleProps: { overflow: 'uset' }, children: _jsx(_Fragment, { children: _jsx(Box, { pt: '0.2rem', w: 'max-content', bg: 'backgroundModal', borderBottomLeftRadius: '0.5rem', borderBottomRightRadius: '0.5rem', sx: {
                            borderWidth: 'thin',
                            borderColor: 'borderColor',
                        }, children: _jsxs(VStack, { spacing: '1rem', m: '1rem', align: 'flex-start', children: [_jsxs(HStack, { children: [_jsx(IconButton, { "aria-label": 'menu close', variant: 'ghost', colorScheme: 'current', isRound: true, icon: _jsx(SlClose, {}), onClick: () => setTogglePackager(false) }), _jsxs(ButtonGroup, { size: 'sm', isAttached: true, variant: 'outline', color: 'text', children: [_jsx(Button, { disabled: true, borderColor: 'gray.400', background: 'buttonBackgroundModal', children: "auth" }), _jsx(Button, { borderColor: 'gray.400', background: 'buttonBackgroundModal', children: deep.linkId }), _jsx(IconButton, { "aria-label": 'close menu', icon: _jsx(CloseIcon, {}), onClick: () => __awaiter(this, void 0, void 0, function* () {
                                                        const guest = yield deep.guest();
                                                        setSpaceId(guest.linkId);
                                                        setContainer(guest.linkId);
                                                    }), borderColor: 'gray.400', background: 'buttonBackgroundModal' })] }), _jsxs(ButtonGroup, { size: 'sm', isAttached: true, variant: 'outline', color: 'text', children: [_jsx(Button, { disabled: true, borderColor: 'gray.400', background: 'buttonBackgroundModal', children: "space" }), _jsx(Button, { borderColor: 'gray.400', background: 'buttonBackgroundModal', children: spaceId }), _jsx(IconButton, { "aria-label": 'Quit to user space', icon: _jsx(CloseIcon, {}), onClick: () => {
                                                        setSpaceId(deep.linkId);
                                                        setContainer(deep.linkId);
                                                    }, borderColor: 'gray.400', background: 'buttonBackgroundModal' })] }), _jsxs(ButtonGroup, { size: 'sm', isAttached: true, variant: 'outline', color: 'text', children: [_jsx(Button, { disabled: true, borderColor: 'gray.400', background: 'buttonBackgroundModal', children: "container" }), _jsx(Button, { borderColor: 'gray.400', background: 'buttonBackgroundModal', children: container }), _jsx(IconButton, { "aria-label": 'Quit to user space', icon: _jsx(CloseIcon, {}), onClick: () => {
                                                        setContainer(deep.linkId);
                                                    }, borderColor: 'gray.400', background: 'buttonBackgroundModal' })] }), _jsxs(ButtonGroup, { size: 'sm', isAttached: true, variant: 'outline', color: 'text', children: [_jsx(Button, { onClick: () => {
                                                        copy(deep.token);
                                                    }, borderColor: 'gray.400', background: 'buttonBackgroundModal', children: "copy token" }), _jsx(Button, { colorScheme: pasteError ? 'red' : valid ? 'blue' : undefined, onClick: () => __awaiter(this, void 0, void 0, function* () {
                                                        var _a;
                                                        if (valid)
                                                            yield deep.login({ token: valid });
                                                        else {
                                                            setPasteError(false);
                                                            const token = yield ((_a = navigator === null || navigator === void 0 ? void 0 : navigator.clipboard) === null || _a === void 0 ? void 0 : _a.readText());
                                                            const { linkId, error } = yield deep.jwt({ token });
                                                            if (error && !linkId)
                                                                setPasteError(true);
                                                            else if (linkId)
                                                                setValid(token);
                                                        }
                                                    }), borderColor: 'gray.400', background: 'buttonBackgroundModal', children: valid ? 'login token' : 'paste token' })] }), _jsx(ButtonGroup, { size: 'sm', isAttached: true, variant: 'outline', color: 'text', children: _jsx(Button, { borderColor: 'gray.400', background: 'buttonBackgroundModal', as: 'a', href: `http${gqlSsl ? 's' : ''}://${gqlPath}`, target: "_blank", children: "gql" }) }), _jsx(ButtonGroup, { size: 'sm', isAttached: true, variant: 'outline', color: 'text', children: _jsx(Button, { borderColor: 'gray.400', background: 'buttonBackgroundModal', onClick: () => setCytoEditor(true), children: "editor" }) })] }), _jsxs(HStack, { spacing: 5, children: [_jsxs(FormControl, { display: 'flex', alignItems: 'center', children: [_jsx(FormLabel, { color: 'text', htmlFor: 'autofocus-on-insert', mb: '0', fontSize: 'sm', mr: '0.25rem', children: "autofocus" }), _jsx(DeepSwitch, { id: 'autofocus-on-insert', isChecked: autoFocus, onChange: () => setAutoFocus(!autoFocus) })] }), _jsxs(FormControl, { display: 'flex', alignItems: 'center', children: [_jsx(FormLabel, { color: 'text', htmlFor: 'show-focus', mb: '0', fontSize: 'sm', mr: '0.25rem', children: "focus" }), _jsx(DeepSwitch, { id: 'show-focus', isChecked: focus, onChange: () => setFocus(!focus) })] }), _jsxs(FormControl, { display: 'flex', alignItems: 'center', children: [_jsx(FormLabel, { color: 'text', htmlFor: 'show-extra-switch', mb: '0', fontSize: 'sm', mr: '0.25rem', children: "debug" }), _jsx(DeepSwitch, { id: 'show-extra-switch', isChecked: extra, onChange: () => setExtra(!extra) })] }), _jsxs(FormControl, { display: 'flex', alignItems: 'center', children: [_jsx(FormLabel, { color: 'text', htmlFor: 'show-types-switch', mb: '0', fontSize: 'sm', mr: '0.25rem', children: "types" }), _jsx(DeepSwitch, { id: 'show-types-switch', isChecked: showTypes, onChange: () => setShowTypes(!showTypes) })] }), _jsxs(FormControl, { display: 'flex', alignItems: 'center', children: [_jsx(FormLabel, { color: 'text', htmlFor: 'show-traveler-switch', mb: '0', fontSize: 'sm', mr: '0.25rem', children: "traveler" }), _jsx(DeepSwitch, { id: 'show-traveler-switch', isChecked: traveler, onChange: () => setTraveler(!traveler) })] }), _jsxs(FormControl, { display: 'flex', alignItems: 'center', children: [_jsx(FormLabel, { color: 'text', htmlFor: 'breadcrumbs-switch', mb: '0', fontSize: 'sm', mr: '0.25rem', children: "breadcrumbs" }), _jsx(DeepSwitch, { id: 'breadcrumbs-switch', isChecked: breadcrumbs, onChange: () => setBreadcrumbs(!breadcrumbs) })] }), _jsxs(FormControl, { display: 'flex', alignItems: 'center', children: [_jsx(FormLabel, { color: 'text', htmlFor: 'cytoHandlers-switch', mb: '0', fontSize: 'sm', mr: '0.25rem', children: "cytoHandlers" }), _jsx(DeepSwitch, { id: 'cytoHandlers-switch', isChecked: cytoHandlers, onChange: () => setCytoHandlers(!cytoHandlers) })] }), _jsxs(FormControl, { display: 'flex', alignItems: 'center', children: [_jsx(FormLabel, { htmlFor: 'animation-layout-switch', mb: '0', fontSize: 'sm', mr: '0.25rem', children: "animation" }), _jsx(DeepSwitch, { id: 'animation-layout-switch', isChecked: layoutAnimation, onChange: () => setLayoutAnimation(!layoutAnimation) })] }), _jsxs(FormControl, { display: 'flex', alignItems: 'center', children: [_jsx(FormLabel, { mb: '0', fontSize: 'sm', mr: '0.55rem', children: "layout" }), _jsx(Box, { width: "max-content", margin: "0 auto", children: _jsx(ListLayout, { layout: layoutName, currentLayout: layoutName, setCurrentLayout: handlerChangeLayout }) })] })] }), _jsxs(HStack, { children: [_jsx(MenuSearch, { cyRef: cyRef, bg: 'buttonBackgroundModal' }), _jsx(ButtonGroup, { size: 'sm', isAttached: true, variant: 'outline', color: 'text', children: _jsx(Button, { onClick: clearFocuses, borderColor: 'gray.400', background: 'buttonBackgroundModal', children: "clear focuses" }) }), _jsx(Travelers, {}), _jsx(CytoHandlersMenu, {})] })] }) }) }) })] }));
}
const Travelers = () => {
    const deep = useDeep();
    const [spaceId] = useSpaceId();
    const { data: Traveler } = useDeepId('@deep-foundation/deepcase', 'Traveler');
    const travelers = deep.useMinilinksSubscription({
        type_id: Traveler || 0,
        in: {
            type_id: deep.idLocal('@deep-foundation/core', 'Contain'),
            from_id: spaceId,
        },
    });
    return _jsx(ButtonGroup, { size: 'sm', isAttached: true, variant: 'outline', color: 'text', children: _jsxs(Popover, { children: [_jsx(PopoverTrigger, { children: _jsx(Button, { children: "Travelers" }) }), _jsxs(PopoverContent, { children: [_jsx(PopoverArrow, {}), _jsx(PopoverCloseButton, {}), _jsx(PopoverBody, { style: { overflowY: 'auto', maxHeight: 300 }, children: _jsx(VStack, { divider: _jsx(StackDivider, { borderColor: 'gray.200' }), spacing: 4, align: 'stretch', children: travelers.map(traveler => {
                                    var _a, _b;
                                    return _jsxs(Box, { children: [_jsx(IconButton, { "aria-label": `Delete traveler ##${traveler.id}`, icon: _jsx(_Fragment, { children: "\u274C" }), onClick: () => {
                                                    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t;
                                                    return deep.delete({
                                                        _or: [
                                                            { id: traveler === null || traveler === void 0 ? void 0 : traveler.id, },
                                                            { id: (_c = (_b = (_a = traveler === null || traveler === void 0 ? void 0 : traveler.inByType) === null || _a === void 0 ? void 0 : _a[deep.idLocal('@deep-foundation/core', 'Contain')]) === null || _b === void 0 ? void 0 : _b.find(l => l.from_id === spaceId)) === null || _c === void 0 ? void 0 : _c.id, },
                                                            { id: traveler === null || traveler === void 0 ? void 0 : traveler.to_id, },
                                                            { id: (_g = (_f = (_e = (_d = traveler === null || traveler === void 0 ? void 0 : traveler.to) === null || _d === void 0 ? void 0 : _d.inByType) === null || _e === void 0 ? void 0 : _e[deep.idLocal('@deep-foundation/core', 'Contain')]) === null || _f === void 0 ? void 0 : _f.find(l => l.from_id === spaceId)) === null || _g === void 0 ? void 0 : _g.id, },
                                                            { id: (_l = (_k = (_j = (_h = traveler === null || traveler === void 0 ? void 0 : traveler.to) === null || _h === void 0 ? void 0 : _h.inByType) === null || _j === void 0 ? void 0 : _j[deep.idLocal('@deep-foundation/core', 'Active')]) === null || _k === void 0 ? void 0 : _k.find(l => l.from_id === spaceId)) === null || _l === void 0 ? void 0 : _l.id, },
                                                            { id: (_t = (_s = (_r = (_q = (_p = (_o = (_m = traveler === null || traveler === void 0 ? void 0 : traveler.to) === null || _m === void 0 ? void 0 : _m.inByType) === null || _o === void 0 ? void 0 : _o[deep.idLocal('@deep-foundation/core', 'Active')]) === null || _p === void 0 ? void 0 : _p.find(l => l.from_id === spaceId)) === null || _q === void 0 ? void 0 : _q.inByType) === null || _r === void 0 ? void 0 : _r[deep.idLocal('@deep-foundation/core', 'Contain')]) === null || _s === void 0 ? void 0 : _s.find(l => l.from_id === spaceId)) === null || _t === void 0 ? void 0 : _t.id, },
                                                        ],
                                                    });
                                                } }), " ", traveler.id, _jsx(Box, { children: _jsx("pre", { children: _jsx("code", { children: JSON.stringify(((_b = (_a = traveler === null || traveler === void 0 ? void 0 : traveler.to) === null || _a === void 0 ? void 0 : _a.value) === null || _b === void 0 ? void 0 : _b.value) || {}, null, 2) }) }) })] });
                                }) }) })] })] }) });
};
const genName = (id, deep) => { var _a, _b, _c; return `${((_c = (_b = (_a = deep.minilinks.byTo[id]) === null || _a === void 0 ? void 0 : _a.find(l => l.type_id === deep.idLocal('@deep-foundation/core', 'Symbol'))) === null || _b === void 0 ? void 0 : _b.value) === null || _c === void 0 ? void 0 : _c.value) || ''} ${deep.nameLocal(id)}`.trim(); };
const CytoHandlersMenu = () => {
    const deep = useDeep();
    const [spaceId] = useSpaceId();
    const { data: [HandleCytoLink] = [] } = useDeepSubscription({
        id: { _id: ['@deep-foundation/handle-cyto', 'HandleCyto'] }
    });
    const HandleCyto = HandleCytoLink === null || HandleCytoLink === void 0 ? void 0 : HandleCytoLink.id;
    const [chr, setChr] = useCytoHandlersRules();
    const hcs = deep.useMinilinksSubscription({
        type_id: HandleCyto || 0,
    });
    return _jsx(ButtonGroup, { size: 'sm', isAttached: true, variant: 'outline', color: 'text', children: _jsxs(Popover, { children: [_jsx(PopoverTrigger, { children: _jsx(Button, { children: "CytoHandlers" }) }), _jsxs(PopoverContent, { style: { width: 400 }, children: [_jsx(PopoverArrow, {}), _jsx(PopoverCloseButton, {}), _jsx(PopoverBody, { style: { overflowY: 'auto', maxHeight: 300 }, children: [_jsx(VStack, { divider: _jsx(StackDivider, { borderColor: 'gray.200' }), spacing: 4, align: 'stretch', children: hcs.map(hc => {
                                        var _a;
                                        return _jsx(Box, { children: _jsxs(HStack, { children: [_jsxs(Box, { children: ["Handle ", genName(hc.from_id, deep), " as ", genName((_a = hc.to) === null || _a === void 0 ? void 0 : _a.to_id, deep)] }), _jsx(DeepSwitch, { isChecked: !!chr[hc.id], onChange: () => {
                                                            setChr(chr => (Object.assign(Object.assign({}, chr), { [hc.id]: !chr[hc.id] })));
                                                        } })] }) });
                                    }) }, JSON.stringify(chr))] })] })] }) });
};
export const MenuSearch = ({ cyRef, bg }) => {
    const deep = useDeep();
    const [value, setValue] = useState('');
    const byId = deep.useMinilinksQuery({
        _or: [
            { id: { _eq: parseInt(value) } },
        ],
    });
    const byValue = deep.useMinilinksQuery({
        value: {
            value: { _ilike: value },
        },
    });
    const byContain = deep.useMinilinksQuery({
        _or: [
            {
                in: {
                    type_id: deep.idLocal('@deep-foundation/core', 'Contain'),
                    value: {
                        value: {
                            _ilike: value,
                            _neq: '',
                        }
                    },
                }
            },
        ],
    });
    const all = [...byId, ...byValue, ...byContain];
    const [index, setIndex] = useState(-1);
    const [selected, setSelected] = useState(0);
    useEffect(() => {
        var _a;
        setSelected((_a = all[index]) === null || _a === void 0 ? void 0 : _a.id);
    }, [index]);
    return _jsx(_Fragment, { children: _jsxs(Popover, { placement: 'bottom-start', autoFocus: false, children: [_jsx(PopoverTrigger, { children: _jsx(Input, { value: value, onChange: (e) => setValue(e.target.value), borderColor: 'gray.400', background: bg }) }), _jsxs(PopoverContent, { children: [_jsx(PopoverHeader, { fontWeight: 'semibold', children: "Search local" }), _jsx(PopoverArrow, {}), _jsx(PopoverCloseButton, {}), _jsxs(PopoverBody, { sx: {
                                height: '30rem',
                                overflow: 'scroll',
                            }, children: [_jsx(Text, { as: "h1", children: "byId" }), byId.map(link => (console.log({ selected, link }),
                                    _jsx(Tag, { borderRadius: 'full', variant: 'solid', colorScheme: selected === link.id ? 'primary' : 'default', onClick: (() => {
                                            const cy = cyRef === null || cyRef === void 0 ? void 0 : cyRef.current;
                                            console.log('cy', cy);
                                            console.log('cy el', `#${link === null || link === void 0 ? void 0 : link.id}`, cy.$(`#${link === null || link === void 0 ? void 0 : link.id}`));
                                            cy.center(cy.$(`#${link === null || link === void 0 ? void 0 : link.id}`));
                                        }), children: _jsx(TagLabel, { children: deep.nameLocal(link.id) || link.id }) }, link.id))), _jsx(Text, { as: "h1", children: "byContain" }), byContain.map(link => (_jsx(Tag, { borderRadius: 'full', variant: 'solid', colorScheme: selected === link.id ? 'primary' : 'default', onClick: (() => {
                                        const cy = cyRef === null || cyRef === void 0 ? void 0 : cyRef.current;
                                        console.log('cy', cy);
                                        console.log('cy el', `#${link === null || link === void 0 ? void 0 : link.id}`, cy.$(`#${link === null || link === void 0 ? void 0 : link.id}`));
                                        cy.center(cy.$(`#${link === null || link === void 0 ? void 0 : link.id}`));
                                    }), children: _jsx(TagLabel, { children: deep.nameLocal(link.id) || link.id }) }, link.id))), _jsx(Text, { as: "h1", children: "byValue" }), byValue.map(link => (_jsx(Tag, { borderRadius: 'full', variant: 'solid', colorScheme: selected === link.id ? 'primary' : 'default', onClick: (() => {
                                        const cy = cyRef === null || cyRef === void 0 ? void 0 : cyRef.current;
                                        console.log('cy', cy);
                                        console.log('cy el', `#${link === null || link === void 0 ? void 0 : link.id}`, cy.$(`#${link === null || link === void 0 ? void 0 : link.id}`));
                                        cy.center(cy.$(`#${link === null || link === void 0 ? void 0 : link.id}`));
                                    }), children: _jsx(TagLabel, { children: deep.nameLocal(link.id) || link.id }) }, link.id)))] })] })] }) });
};
//# sourceMappingURL=menu.js.map