import { jsxs as _jsxs, jsx as _jsx } from "react/jsx-runtime";
import React from 'react';
import { Flex, Box } from '@chakra-ui/react';
import { useDeep } from '@deep-foundation/deeplinks/imports/client';
export const EditorResultsResolvesRejects = React.memo(({ promiseId }) => {
    const deep = useDeep();
    const resolves = deep.useMinilinksSubscription({
        type_id: deep.idLocal('@deep-foundation/core', 'Resolved'),
        from_id: promiseId,
    });
    const rejects = deep.useMinilinksSubscription({
        type_id: deep.idLocal('@deep-foundation/core', 'Rejected'),
        from_id: promiseId,
    });
    return _jsxs(Box, { children: [resolves.map(resolved => _jsxs(Box, { children: [resolved.id, " Resolved"] })), rejects.map(rejected => _jsxs(Box, { children: [rejected.id, " Resolved"] }))] });
});
export const EditorResults = React.memo(({ id, }) => {
    const deep = useDeep();
    deep.useDeepSubscription({
        up: {
            parent: {
                type_id: deep.idLocal('@deep-foundation/core', 'Then'),
                from_id: id,
            },
        }
    });
    const promises = deep.useMinilinksSubscription({
        type_id: deep.idLocal('@deep-foundation/core', 'Promise'),
        in: {
            type_id: deep.idLocal('@deep-foundation/core', 'Then'),
            from_id: id,
        },
    });
    const sortedPromises = promises.sort((a, b) => b.id - a.id);
    return (_jsx(Flex, { direction: 'column', position: "relative", children: _jsx(Box, { position: "absolute", width: "100%", height: "100%", overflowY: "scroll", children: _jsx(Box, { children: sortedPromises.map(promise => _jsxs(Box, { children: [promise.id, " Promise", _jsx(Box, { paddingLeft: 4, children: _jsx(EditorResultsResolvesRejects, { promiseId: promise.id }) })] })) }) }) }));
});
//# sourceMappingURL=editor-results.js.map