var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import axios from 'axios';
import { useCallback, useState } from 'react';
import { useLocalStore } from '@deep-foundation/store/local';
import { useApolloClient } from '@deep-foundation/react-hasura/use-apollo-client';
const _call = (serverUrl, options) => axios.post(`${serverUrl}/api/deeplinks`, options).then(console.log, console.log);
export const NEXT_PUBLIC_ENGINES = !!+process.env.NEXT_PUBLIC_ENGINES;
let _useEngineConnected;
if (NEXT_PUBLIC_ENGINES) {
    _useEngineConnected = function useEngineConnected() {
        return useLocalStore('dc-connected', false);
    };
}
else {
    _useEngineConnected = function useEngineConnected() {
        const s = useState(true);
        return [true, s[1]];
    };
}
export const useEngineConnected = _useEngineConnected;
export function useEnginePath() {
    return useLocalStore('dc-path', '');
}
export function useEngine(serverUrl) {
    const client = useApolloClient();
    const [connected, setConnected] = useEngineConnected();
    const [operation, setOperation] = useState('');
    const call = useCallback((options) => __awaiter(this, void 0, void 0, function* () {
        setOperation(options.operation);
        if (['reset', 'sleep'].includes(options.operation)) {
            setConnected(false);
        }
        yield _call(serverUrl, options);
        if (['run'].includes(options.operation)) {
            setConnected(true);
        }
        setOperation('');
    }), []);
    return {
        operation,
        call,
    };
}
//# sourceMappingURL=engine.js.map