import React from 'react';
import { Link } from '@deep-foundation/deeplinks/imports/minilinks';
export declare const defaultLeftWidth = 10;
export declare const defaultCardWidth = 300;
export declare function useClickSelect(): [boolean, (value: boolean) => boolean, () => boolean];
export declare function useTraveler(): [boolean, (value: boolean) => boolean, () => boolean];
export declare function useContainer(): any[];
export declare function useForceGraph(): [string, (value: string) => string, () => string];
export interface IInsertingCytoStore {
    isNode?: boolean;
    isPossibleNode?: boolean;
    type_id?: number;
    toast?: any;
    From?: number;
    To?: number;
    from?: number;
    to?: number;
    _selfLink?: boolean;
}
export declare function useInsertingCytoStore(): [IInsertingCytoStore, (value: IInsertingCytoStore) => IInsertingCytoStore, () => IInsertingCytoStore];
export interface IUpdatingCytoStore {
    id?: number;
    toast?: any;
    _selfLink?: boolean;
    from?: number;
    to?: number;
}
export declare function useUpdatingCytoStore(): [IUpdatingCytoStore, (value: IUpdatingCytoStore) => IUpdatingCytoStore, () => IUpdatingCytoStore];
export declare function useScreenFind(): [any, (value: any) => any, () => any];
export declare function useSpaceId(): any[];
export declare function useWindowSize(): [{
    width: number;
    height: number;
}, (value: {
    width: number;
    height: number;
}) => {
    width: number;
    height: number;
}, () => {
    width: number;
    height: number;
}];
export declare function useAutoFocusOnInsert(): [boolean, (value: boolean) => boolean, () => boolean];
export declare function useShowExtra(): [any, (value: any) => any, () => any];
export declare function useCytoViewport<S extends {
    pan: {
        x: number;
        y: number;
    };
    zoom: number;
}>(): [S, (value: S) => S, () => S];
export declare function useShowFocus(): [any, (value: any) => any, () => any];
export declare function useCytoHandlersSwitch(): [any, (value: any) => any, () => any];
export declare function useBreadcrumbs(): [any, (value: any) => any, () => any];
export declare function useLayoutAnimation(): [any, (value: any) => any, () => any];
export declare function useReserved(): [any, (value: any) => any, () => any];
export declare function useShowTypes(): [boolean, (value: boolean) => boolean, () => boolean];
export declare function useBackgroundTransparent(): [any, (value: any) => any, () => any];
export declare function useFocusMethods(): {
    unfocus: (id: any) => Promise<void>;
    focus: (id: any, value: {
        x: number;
        y: number;
        z: number;
    }) => Promise<void>;
};
export declare function useActiveMethods(): {
    deactive: (id: number) => Promise<void>;
    find: (id: number) => Promise<Link<number>>;
    active: (id: number) => Promise<void>;
    toggle: (id: number) => Promise<void>;
};
export declare function useLayout(): {
    setLayout(name: 'cola' | 'deep-d3-force'): void;
    layout: any;
    layoutName: string;
};
export declare function useRefAutofill<T>(value: T): React.MutableRefObject<T>;
export declare const useMediaQuery: (arg: any) => boolean[];
export declare const useAsyncState: (defaultValue: any, init: any, depends?: any[]) => any;
