import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React from 'react';
import { Flex, Text, Box } from '@chakra-ui/react';
import { motion } from 'framer-motion';
export const Loading = React.memo(({ text, width = '0.1875rem', height = '0.1875rem', sxFlex, justifyFlex = 'space-between', widthFlex = '100%', sx, borderRadiusBubble = '0.125rem', backgroundBubble = "#A0AEC0", }) => {
    return (_jsxs(Flex, { width: widthFlex, justify: justifyFlex, sx: sxFlex, children: [_jsx(Text, { color: 'gray.400', fontSize: 'sm', as: 'kbd', mr: '0.125rem', children: text }), _jsxs(Box, { display: 'flex', w: '100%', justifyContent: 'flex-start', alignItems: 'flex-end', sx: Object.assign({ '& > *:not(:last-of-type)': {
                        mr: 1
                    } }, sx), children: [_jsx(motion.div, { style: {
                            width: width,
                            height: height,
                            borderRadius: borderRadiusBubble,
                            backgroundColor: backgroundBubble,
                        }, animate: { scale: [0, 1, 0] }, transition: { duration: 2, repeat: Infinity } }), _jsx(motion.div, { style: {
                            width: width,
                            height: height,
                            borderRadius: borderRadiusBubble,
                            backgroundColor: backgroundBubble,
                        }, animate: { scale: [0, 1, 0] }, transition: { duration: 2, repeat: Infinity, delay: 0.4 } }), _jsx(motion.div, { style: {
                            width: width,
                            height: height,
                            borderRadius: borderRadiusBubble,
                            backgroundColor: backgroundBubble,
                        }, animate: { scale: [0, 1, 0] }, transition: { duration: 2, repeat: Infinity, delay: 0.8 } }), _jsx(motion.div, { style: {
                            width: width,
                            height: height,
                            borderRadius: borderRadiusBubble,
                            backgroundColor: backgroundBubble,
                        }, animate: { scale: [0, 1, 0] }, transition: { duration: 2, repeat: Infinity, delay: 1.6 } })] })] }));
});
//# sourceMappingURL=loading-motion-bubble.js.map