var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { ExternalLinkIcon } from '@chakra-ui/icons';
import { Box, Button, Input, Link, VStack } from '@chakra-ui/react';
import { useState } from 'react';
import { useDeep } from '@deep-foundation/deeplinks/imports/client';
import { makeUseAxios } from "axios-hooks";
import axios from "axios";
const useAxios = makeUseAxios({ axios: axios.create() });
export const PackagePublisher = () => {
    var _a, _b, _c, _d;
    const deep = useDeep();
    const packageId = 742;
    const packageTypeId = deep.idLocal('@deep-foundation/core', 'Package');
    const packageNamespaceTypeId = deep.idLocal('@deep-foundation/core', 'PackageNamespace');
    const packageVersionTypeId = deep.idLocal('@deep-foundation/core', 'PackageVersion');
    const { data: prefetched } = deep.useDeepSubscription({
        type_id: { _in: [packageTypeId, packageNamespaceTypeId, packageVersionTypeId] }
    });
    const pkg = deep.minilinks.byId[packageId];
    const pkgVersion = (_b = (_a = pkg === null || pkg === void 0 ? void 0 : pkg.in) === null || _a === void 0 ? void 0 : _a.filter(v => v.type_id === packageVersionTypeId)) === null || _b === void 0 ? void 0 : _b[0];
    const pkgVersionValue = ((_c = pkgVersion === null || pkgVersion === void 0 ? void 0 : pkgVersion.value) === null || _c === void 0 ? void 0 : _c.value) || "";
    const packageNamespaceId = pkgVersion === null || pkgVersion === void 0 ? void 0 : pkgVersion.from_id;
    const packageName = ((_d = pkg === null || pkg === void 0 ? void 0 : pkg.value) === null || _d === void 0 ? void 0 : _d.value) || "";
    const [currentPackageName, setCurrentPackageName] = useState(packageName);
    const [currentPackageVersion, setCurrentPackageVersion] = useState(pkgVersionValue);
    let packageUrl = `https://registry.npmjs.com/${currentPackageName}`;
    const [{ data, loading, error }, refetch] = useAxios(packageUrl);
    console.log(`useAxios(packageUrl)`, data, loading, error);
    if (!data) {
        packageUrl = undefined;
    }
    return (_jsxs(Box, { maxW: 'md', borderColor: 'gray.400', borderWidth: '1px', borderRadius: 'lg', overflow: 'hidden', children: [packageUrl ? _jsxs(Link, { fontSize: 'xs', href: packageUrl, p: 2, isExternal: true, children: [packageUrl, " ", _jsx(ExternalLinkIcon, { mx: '2px' })] }) : null, _jsxs(VStack, { p: 2, children: [_jsx(Input, { placeholder: 'package name', value: currentPackageName, borderColor: 'gray.300', size: 'sm', onChange: (e) => setCurrentPackageName(e.target.value) }), _jsx(Input, { placeholder: 'package version', value: currentPackageVersion, borderColor: 'gray.300', size: 'sm', onChange: (e) => setCurrentPackageVersion(e.target.value) }), _jsx(Button, { colorScheme: 'blue', size: 'sm', w: '100%', onClick: () => __awaiter(void 0, void 0, void 0, function* () {
                            if (!packageNamespaceId && currentPackageName) {
                                const { data: [{ id: namespaceId }] } = yield deep.insert({
                                    type_id: packageNamespaceTypeId,
                                    string: { data: { value: currentPackageName } },
                                });
                            }
                            else if (currentPackageName) {
                                yield deep.update({ link_id: packageNamespaceId }, { value: currentPackageName }, { table: 'strings' });
                            }
                            if (currentPackageName) {
                                yield deep.update({ link_id: pkg === null || pkg === void 0 ? void 0 : pkg.id }, { value: currentPackageName }, { table: 'strings' });
                            }
                            if (!(pkgVersion === null || pkgVersion === void 0 ? void 0 : pkgVersion.id)) {
                                const { data: [{ id: packageVersionId }] } = yield deep.insert({
                                    type_id: packageVersionTypeId,
                                    string: { data: { value: currentPackageVersion || '0.0.0' } },
                                });
                            }
                            else if (currentPackageVersion) {
                                yield deep.update({ link_id: pkgVersion === null || pkgVersion === void 0 ? void 0 : pkgVersion.id }, { value: currentPackageVersion }, { table: 'strings' });
                            }
                        }), children: "save" }), _jsx(Button, { colorScheme: 'blue', size: 'sm', w: '100%', children: "publish" })] })] }));
};
//# sourceMappingURL=package-publisher.js.map