import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { Box, Flex, Popover, PopoverArrow, PopoverBody, PopoverContent, PopoverTrigger, Text, Textarea, useColorModeValue } from '@chakra-ui/react';
import React, { useCallback, useEffect, useRef, useState } from 'react';
import { TypeIcon } from '../cyto-react-links-card';
import { useChackraColor } from '../get-color';
const variants = {
    opened: {
        opacity: 1
    },
    exited: {
        opacity: 0,
        transition: { duration: 0.9 }
    }
};
export const TextInput = React.memo(() => {
    const [value, setValue] = useState('');
    const inputRef = useRef();
    const handleInputChange = (e) => {
        let inputValue = e.target.value;
        setValue(inputValue);
    };
    useEffect(() => {
        var _a;
        let position = (_a = inputRef === null || inputRef === void 0 ? void 0 : inputRef.current) === null || _a === void 0 ? void 0 : _a.selectionStart;
    });
    return (_jsx(Textarea, { ref: inputRef, value: value, onChange: (e) => handleInputChange(e), placeholder: 'Here is a sample placeholder', size: 'sm' }));
});
export const TooltipEmoji = React.memo(({ selectedLinkId = 0, data, }) => {
    const whiteAlpha = useChackraColor('whiteAlpha.600');
    const blackAlpha = useChackraColor('blackAlpha.300');
    const borderColorSelected = useChackraColor('primary');
    const colorGrayToWhite = useColorModeValue(blackAlpha, whiteAlpha);
    const [selectedLink, setSelectedLink] = useState(selectedLinkId);
    const selectLink = useCallback((linkId) => {
        setSelectedLink((prevLinkId) => prevLinkId == linkId ? 0 : linkId);
    }, []);
    const [isOpen, setIsOpen] = React.useState(false);
    const open = () => setIsOpen(!isOpen);
    const close = () => setIsOpen(false);
    return (_jsxs(Popover, { returnFocusOnClose: false, isOpen: isOpen, onOpen: open, onClose: close, placement: 'right', closeOnBlur: false, size: 'sm', arrowShadowColor: 'none', children: [_jsx(PopoverTrigger, { children: _jsx(Box, { w: 'max-content', h: '100%', children: "Popover Target" }) }), _jsxs(PopoverContent, { sx: {
                    boxShadow: '0 0 0',
                    '& [data-focus-visible]': {
                        borderColor: 'none'
                    }
                }, _focusVisible: { boxShadow: '0 0 0', outlineColor: 'transparent', border: 'none', }, children: [_jsx(PopoverArrow, {}), _jsx(PopoverBody, { overflow: 'scroll', sx: {
                            p: 1.5,
                            overscrollBehavior: 'contain',
                            boxSizing: 'border-box',
                            '::-webkit-scrollbar': {
                                display: 'none',
                            },
                        }, children: _jsx(Box, { w: 'max-content', h: '100%', children: _jsx(Flex, { sx: {
                                    '& > *:not(:last-of-type)': {
                                        mr: '0.4rem',
                                    }
                                }, children: data.map((t) => _jsx(TypeIcon, { src: t.src, borderWidth: selectedLink === t.id ? 2 : 1, borderColor: selectedLink === t.id ? borderColorSelected : colorGrayToWhite, _hover: {
                                        borderColor: 'primary'
                                    }, onClick: selectLink }, t.id)) }) }) })] })] }));
});
export const TooltipExample = React.memo(({ open }) => {
    return (_jsx(Text, { onClick: open, as: 'div', fontSize: 'xl', children: "Tooltip" }));
});
//# sourceMappingURL=text-cursor-tooltip.js.map